/*############################################################################
#                                                                            #
#             VAEEP-ROM AT93C46D hCo(8BITp)                    #
#                                                                            #
#@RpCmFFAVR studio 4.18(SP3) + WinAVR-20100110                #
#                                                                            #
#@F                                                                    #
#    {IC8bit[h16[h2ނT|[gĂ邪{hCoł     #
#    8rbg[ĥ݂ɑΉĂB                                       #
#    ]āAORG[qLow(GND)ɂKvB                             #
#    ܂ACS[q̓v_EĂSƎvB                  #
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@#
#@@HdqʏMACAhXݍϕĩf[^ȉɎB             #
#           +0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F 10 11            #
#    0000 : 40 00 10 00 00 02 CD xx xx xx 00 00 00 00 00 00 00 00            #
#    擪4oCgMACAhXʎqi40-00-10-00 Œj		             	 #
#    3oCg̓x_[ID(00-02-CD)										 #
#    3oCg̓VAԍ(xx-xx-xx)									 #
#    8oCg0Ŗ߂Ă											 #
#    MACAhX̓x_[ID + VAԍ6oCgł                   #
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@#
#    ڑj SI  ---  PB3                                                   #
#             SO  ---  PB4                                                   #
#             SK  ---  PB5                                                   #
#             CS  ---  PB2                                                   #
#             ORG ---  GND                                                   #
#                                                  2012/11/25 Create by nPYO #
############################################################################*/
#define __AT93C46D_C__

#include <avr/io.h>
#include <util/delay.h>
#include "at93c46d.h"

/* SPIWX^`			*/
#define SPI_TYPE EEP_SPI_MODE		/* 0:soft 1:SPIport 2:USART0 3:USART1	*/

#define SPI_MOSI_PIN EEP_SI_PIN		/* MOSIɊĂ|[g					*/
#define SPI_MOSI_BIT EEP_SI_BIT		/* MOSIɊĂ|[g̃rbgԍ		*/

#define SPI_MISO_PIN EEP_SO_PIN		/* MISOɊĂ|[g					*/
#define SPI_MISO_BIT EEP_SO_BIT		/* MISOɊĂ|[g̃rbgԍ		*/

#define SPI_SCK_PIN EEP_SCK_PIN		/* SCKɊĂ|[g					*/
#define SPI_SCK_BIT EEP_SCK_BIT		/* SCKɊ蓖Ă|[g̃rbgԍ	*/

#include "../myutil/spi_func.h"

/* CS}N`			*/
#define EEP_CS_DDR  ( *(volatile uint8_t *)( &EEP_CS_PIN + 0x01 ) )
#define EEP_CS_PORT ( *(volatile uint8_t *)( &EEP_CS_PIN + 0x02 ) )

#define AT93C46_CS_ENABLE()		{ EEP_CS_PORT |=  _BV( EEP_CS_BIT ); }
#define AT93C46_CS_DISABLE()	{ EEP_CS_PORT &= ~_BV( EEP_CS_BIT ); }

/*****************************************************************************
*								ݒ
* Fvoid
* ߒlFvoid
*****************************************************************************/
void at93c46_init( void )
{
	/* SPI					*/
	spiInit();
	SPI_LOW_SPEED();

	/* CS|[g				*/
	EEP_CS_PORT &= ~_BV( EEP_CS_BIT );
	EEP_CS_DDR  |=  _BV( EEP_CS_BIT );
}

/*****************************************************************************
*						EEP-ROMuAT93C46Dv1oCg[h
* Fuint8_t addr ǍAhXi0x00`0x7f)
* ߒlFuint8_t      Ǎ񂾃oCgf[^
*
* LAhX7rbg( a6 ` a0 )
*****************************************************************************/
uint8_t at93c46_read_byte( uint8_t addr )
{
	uint8_t d1 = 0 ,d2 = 0;

	SPI_LOW_SPEED();

	if ( !( addr & 0x80 ) ) {
		AT93C46_CS_ENABLE();				/* EEP CSL				*/

		/* 1st output					*/
		/* SB      1-------            	*/
		/* OP      -10-----				*/
		/* Address ---65432				*/
		/* SB | OP | Address 𑗐M		*/
		/* Mf[^͈ӖȂ	*/
		spiTransfer( 0xc0 | ( addr >> 2 ) );

		/* 2nd output / input			*/
		/* Address 10------				*/
		/* Address𑗐M				*/
		/* f[^̏5bitM	*/
		/* Output ---76543				*/
		d1 = spiTransfer( addr << 6 ) << 3;

		/* 3rd output / input			*/
		/* _~[0x00𑗐M			*/
		/* f[^̉3bitM	*/
		/* input   210-----				*/
		d2 = spiTransfer( 0x00 ) >> 5;

		AT93C46_CS_DISABLE();			/* EEP CS				*/
	}

	return ( d1 | d2 );					/* Mf[^			*/
}

#if USE_WRITE_FUNC
/*****************************************************************************
*						EEP-ROMuAT93C46Dv1oCgCg
* Fuint8_t addr AhXi0x00`0x7f)
*		uint8_t data f[^
* ߒlFvoid
*
* LAhX7rbg( a6 ` a0 )
*   ̓CgveNgĂ̂ŁAat93c46_ewen()ŏ݂
*   ȂΏ݂sȂB
*   ÖׁAݏÍAat93c46_ewds()ŃveNgĂǂB
*****************************************************************************/
void at93c46_write_byte( uint8_t addr ,uint8_t data )
{
	SPI_LOW_SPEED();

	if ( !( addr & 0x80 ) ) {
		AT93C46_CS_ENABLE();				/* EEP CSL				*/

		/* 1st output					*/
		/* SB      1-------            	*/
		/* OP      -01-----				*/
		/* Address ---65432				*/
		spiTransfer( 0xa0 | ( addr >> 2 ) );

		/* 2nd output					*/
		/* Address 10------				*/
		/* Data    --765432				*/
		spiTransfer( ( addr << 6 ) | ( data >> 2 ) );

		/* 3rd output					*/
		/* Data    10------				*/
		spiTransfer( data << 6 );

		AT93C46_CS_DISABLE();				/* EEP CS				*/
		_delay_us( 10 );

		/* busy҂					*/
		AT93C46_CS_ENABLE();
		while ( !spiTransfer( 0x00 ) );
		AT93C46_CS_DISABLE();
	}

}

/*****************************************************************************
*						EEP-ROMuAT93C46Dvւ݂̏
* Fvoid
* ߒlFvoid
*****************************************************************************/
void at93c46_ewen( void )
{
	SPI_LOW_SPEED();

	AT93C46_CS_ENABLE();
	spiTransfer( 0x98 );
	spiTransfer( 0x00 );
	AT93C46_CS_DISABLE();
}

/*****************************************************************************
*						EEP-ROMuAT93C46Dvւ݂̏֎~
* Fvoid
* ߒlFvoid
*****************************************************************************/
void at93c46_ewds( void )
{
	SPI_LOW_SPEED();

	AT93C46_CS_ENABLE();
	spiTransfer( 0x80 );
	spiTransfer( 0x00 );
	AT93C46_CS_DISABLE();
}
#endif
