/*###############################################################################################
#                                                                          					    #
#                               J_[֘AW[    	          					    #
#                                                                          					    #
# CEX -> OSIϊASYQlURL											#
# http://delfusa.main.jp/delfusafloor/archive/www.nifty.ne.jp_forum_fdelphi/samples/00850.html	#
#                                                                                               #
###############################################################################################*/
#define __DATE_C__

#include <avr/io.h>
#include <avr/pgmspace.h>
#include "date.h"

#if __USE_DATE_DAY2WEEK__
/*****************************************************************************
*							tjvZ
* Fuint16_t year  
*       uint8_t  month 
*		uint8_t  day   
* ߒlFuint8_t        jiOF@PF@QF΁@EEE@UFyj
*****************************************************************************/
uint8_t date_day2week( uint16_t y ,uint8_t m ,uint8_t d )
{
	if ( m <= 2 ) {
		y--;
		m += 12;
	}
	uint8_t week = ( ( y + ( y / 4 ) - ( y / 100 ) + ( y / 400 ) + ( ( 13 * m + 8 ) / 5 ) + d ) % 7 );
	return ( week );
}
#endif

#if __USE_DATE_GREG2MJD__
/*****************************************************************************
*	OSICEX(1858N1117N_Ƃʓjɕϊ
* Fuint16_t year  
*       uint8_t  month 
*		uint8_t  day   
* ߒlFuint32_t       CEX
*****************************************************************************/
uint32_t date_greg2mjd( uint16_t year ,uint8_t month ,uint8_t day )
{
	uint32_t a;
	uint16_t b;

	/* t[Q̌ɂMJĎvZ		*/
	if ( month <= 2 ) {		/* 12͑ONƂČvZ	*/
		month += 12;
		year--;
	}

	a = ( 36525L * (uint32_t)year ) / 100L;
	b = ( year / 400 ) + ( ( 3059 * ( (uint16_t)month - 2 ) ) / 100 ) + (uint16_t)day - ( year / 100 );

	return ( a + (uint32_t)b - 678912L );
}
#endif

#if __USE_DATE_MJD2GREG__
/*****************************************************************************
*	CEX(1858N1117N_ƂʓjOSIɕϊ
* Fuint32_t mjd    CEX
*       uint16_t *year  i[ϐւ̃|C^
*       uint8_t  *month i[ϐւ̃|C^
*		uint8_t  *day   i[ϐւ̃|C^
*		uint8_t  *wday  j(0: ` 6:y)i[ϐւ̃|C^
* ߒlFvoid
*****************************************************************************/
void date_mjd2greg( uint32_t mjd ,uint16_t *year ,uint8_t *month ,uint8_t *day ,uint8_t *wday )
{
	uint32_t mjd1 ,mjd2;
	uint16_t a;
	uint16_t md;
	uint16_t y ,m ,d;

	/* ߂lNA					*/
	*year = 0;
	*month = 0;
	*day = 0;

	/* jvZ						*/
	*wday = ( mjd - 4L ) % 7;

	/* NvZ						*/
	mjd1 = mjd + 678882UL;
	y = (uint16_t)( mjd1 / 365L ) - 2;
	do {
		a = ( y / 4 ) + ( y / 400 ) + 306 - ( y / 100 );
		mjd2 = ( (uint32_t)y * 365L ) + (uint32_t)a;
		y--;
	} while ( mjd2 >= mjd1 );
	y += 2;

	/* vZ / vZ				*/
	d = (uint16_t)( mjd - date_greg2mjd( (uint16_t)y ,1 ,1 ) ) + 1;
	for ( m = 1 ;m <= 12 ;m++ ) {
		md = date_daysOfMonth( y ,m );
		if ( d <= md ) {
			*year = y;
			*month = (uint8_t)m;
			*day = (uint8_t)d;
			break;
		}
		d -= md;
	}
}
#endif

#if __USE_DATE_DAYSOFMONTH__
/*****************************************************************************
*						w̔NE̓擾
*	Fuint16_t year  N
*		  uint8_t  month 
*	ߒlFuint8_t     	  28`31
*****************************************************************************/
uint8_t date_daysOfMonth( uint16_t year ,uint8_t month )
{
	static const prog_int8_t dfm[] = { 31 ,28 ,31 ,30 ,31 ,30 ,31 ,31 ,30 ,31 ,30 ,31 };

	if ( ( month == 2 ) && IS_LEAP_YEAR( year ) ) {
		return ( 29 );
	}

	return ( pgm_read_byte( &dfm[ month - 1 ] ) );
}
#endif
