/*###########################################################################
#                                                                           #
#								񑀍֐Q						@@#
#                                                                           #
#                                            2012.12.08 strcpy_s() ֐C #
###########################################################################*/
#define __STRING_FUNC_C__

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include "string_func.h"

#if USE_ISDECIMALNUMBER
/*****************************************************************************
*						w蕶10iȂ̂mF
* Fchar c    
* ߒlFuint8_t   0:ł͂Ȃ
*				  1:
*****************************************************************************/
uint8_t isDecimalNumber( char c )
{
	if ( ( c < '0' ) || ( c > '9' ) ) {
		return ( 0 );
	}
	return ( 1 );
}
#endif

#if USE_ISHEXNUMBER
/*****************************************************************************
*						w蕶16iȂ̂mF
* Fchar c    
* ߒlFuint8_t   0:16ił͂Ȃ
*				  1:16i
*****************************************************************************/
uint8_t isHexNumber( char c )
{
	if ( ( ( c >= '0' ) && ( c <= '9' ) ) || ( ( c >= 'A' ) && ( c <= 'F' ) ) || ( ( c >= 'a' ) && ( c <= 'f' ) ) ) {
		return ( 1 );
	}
	return ( 0 );
}
#endif

#if USE_ISDECIMALNUMBERSTRING
/*****************************************************************************
*						10iȂ̂mF
* Fchar *str 
* ߒlFuint8_t   0:ł͂Ȃ
*				  1:
*****************************************************************************/
uint8_t isDecimalNumberString( char *str )
{
	while ( *str ) {
		if ( !isDecimalNumber( *str++ ) ) {
			return ( 0 );
		}
	}
	return ( 1 );
}
#endif

#if USE_ISHEXNUMBERSTRING
/*****************************************************************************
*						16iȂ̂mF
* Fchar *str 
* ߒlFuint8_t   0:16ił͂Ȃ
*				  1:16i
*****************************************************************************/
uint8_t isHexNumberString( char *str )
{
	while ( *str ) {
		if ( !isHexNumber( *str++ ) ) {
			return ( 0 );
		}
	}
	return ( 1 );
}
#endif

#if USE_ATOU16
/*****************************************************************************
*							10iȂ𐔒lɕϊ
* Fchar     *str ϊiÕXy[X͖j
*		uint16_t *val ϊl
* ߒlFuint8_t       0:OK !0:NG
*****************************************************************************/
uint8_t atou16( char *str ,uint16_t *val )
{
	uint8_t c;
	uint32_t n = 0L;

	*val = 0;

	/* 󔒕XLbv			*/
	do {
		c = *str++;
	} while ( c == ' ' );

	/* lϊ						*/
	while ( c != '\0' ) {
		if ( ( c >= '0' ) && ( c <= '9' ) ) {
			n *= 10L;
			n += (uint32_t)( c - '0' );
			if ( n > 65535L ) {
				return ( 1 );
			}
		} else if ( c == ' ' ) {
			break;

		} else {
			return ( 1 );
		}
		c = *str++;
	}

	*val = (uint16_t)n;
	return ( 0 );
}
#endif

#if USE_HTOU16
/*****************************************************************************
*							16i𐔒lɕϊ
* Fchar     *str ϊ
*		uint16_t *val ϊl
* ߒlFuint8_t       0:OK !0:NG
*****************************************************************************/
uint8_t htou16( char *str ,uint16_t *val )
{
	*val = 0;
	if ( ( strlen( str ) <= 4 )  && ( isHexNumberString( str ) != 0 ) ) {	/* 4ȓ16iۏ	*/
		while ( *str ) {
			(*val) <<= 4;
			if ( *str <= '9' ) {
				(*val) += (uint16_t)( *str - '0' );
			} else {
				(*val) += (uint16_t)( ( *str | 0x20 ) - ( 'a' - 10 ) );
			}
			str++;
		}
		return ( 0 );
	}
	return ( 1 );
}
#endif

#if USE_UTOA_KANMA
/*****************************************************************************
*				3̃J}ŋ؂ɕϊ
* Fuint32_t n  l
*       char     *s ϊ㕶
*		uint8_t  k  
* ߒlFvoid
* ɖȂ ' ' Ŗ߂
*****************************************************************************/
void utoa_kanma( uint32_t n ,char *s ,uint8_t k )
{
	static const prog_char tbl[] = { '0' ,'1' ,'2' ,'3' ,'4' ,'5' ,'6' ,'7' ,'8' ,'9' };
	uint8_t i = 0;

	memset( s ,' ' ,k );
	s += k;
	*s-- = '\0';

	do {
		*s-- = pgm_read_byte( &tbl[ n % 10L ] );
		n /= 10L;
		i++;
		if ( ( n != 0 ) && ( ( i % 3 ) == 0 ) ) {
			*s-- = ',';
		}
	} while ( n != 0L );
}
#endif

#if USE_TRIM
/*****************************************************************************
*						̑Ő󔒕(0x20)폜
*@Fchar *s 
*@ߒlFvoid
*****************************************************************************/
void strtrim( char *s )
{
	char *p = s;

	/* ÕXy[X			*/
	while ( *p && ( *p <= ' ' ) ) {
		p++;
	}
	if ( s != p ) {
		strcpy( s ,p );
	}

	/* 㔼̃Xy[X			*/
	uint16_t len = strlen( s );
	if ( len ) {
		s += ( len - 1 );
		while ( ( len-- ) && ( *s <= ' ' ) ) {
			*(s--) = '\0';
		}
	}
}
#endif

#if USE_INSTRREV
/*****************************************************************************
*				̍Ōォw̃LN^
*@Fchar *s 
*		 char c  ( 0x3fȉ̕R[ĥ )
*@ߒlFchar *  ʒũ|C^
*****************************************************************************/
char *inStrRev( char *s ,char c )
{
	char *p = NULL;
	do {
		if ( *s == c ) {
			p = s;
		}
	} while ( *s++ );
	return ( p );
}

#if USE_GETFILENAME
/*****************************************************************************
*		t@CtpX(8.3`)t@C擾(gqtj
* Fchar *path	tpX
* ߒlFchar *     t@Cւ̃|C^
*****************************************************************************/
char *getFileName( char *path )
{
	char *p = inStrRev( path ,'/' );
	if ( p == NULL ) {
		p = inStrRev( path ,'\\' );
	}

	if ( p == NULL ) {
		p = path;
	} else {
		p++;
	}

	return ( p );
}

#if USE_GETEXTENSION
/*****************************************************************************
*						t@CtpXgq擾
* Fchar *path	tpX
* ߒlFchar *gqւ̃|C^
*****************************************************************************/
char *getExtension( char *path )
{
	char *p = inStrRev( path ,'.' );
	if ( p == NULL ) {
		return ( NULL );
	}
	return ( p + 1 );
}

#if USE_GETFILEPATH
/*****************************************************************************
*					t@CtpXpX擾
* Fchar *fname tpXt@C
*		char *path  pXޔ̈
* ߒlFvoid
*****************************************************************************/
void getFilePath( char *fname ,char *path )
{
	char *p = inStrRev( fname ,'/' );
	if ( p == NULL ) {
		p = inStrRev( fname ,'\\' );
		if ( p == NULL ) {
			path[0] = '\0';
		}
	}

	if ( p != NULL ) {
		*p = '\0';
		strcpy( path ,fname );
		*p = '/';
	}
}

#endif
#endif
#endif
#endif

#if USE_GETCHARCODE
/*****************************************************************************
*				̐擪R[h擾(S-JISΉ)
* Fchar   **s ւ̃|C^
* ߒl:uint16_t    擾R[h(R[h擾ƕ|C^iށj
*****************************************************************************/
uint16_t getCharCode( char **s )
{
	char *p = *s;
	uint16_t code = (uint16_t)*p++;
	if ( IS_SJIS1( code ) ) {
		if ( IS_SJIS2( *p ) ) {
			code <<= 8;
			code |= (uint16_t)*p++;
		}
	}
	*s = p;
	return ( code );
}

/*****************************************************************************
*				̐擪R[h擾(S-JISΉ)
* Fprog_char   **s ւ̃|C^
* ߒlFuint16_t    擾R[h(R[h擾ƕ|C^iށj
*****************************************************************************/
uint16_t getCharCode_P( prog_char **s )
{
	prog_char *p = *s;
	uint16_t code = (uint16_t)pgm_read_byte( p++ );
	if ( IS_SJIS1( code ) ) {
		if ( IS_SJIS2( pgm_read_byte( p ) ) ) {
			code <<= 8;
			code |= (uint16_t)pgm_read_byte( p++ );
		}
	}
	*s = p;
	return ( code );
}
#endif

#if USE_STRCAT_S
/*****************************************************************************
*							A(ZLeBΉ)
* Fchar *strDestination       Aobt@
*       uint16_t numberOfElements  obt@TCY
*       char *strSource            A
* ߒlFuint8_t  0:OK !0:obt@I[o[
*****************************************************************************/
uint8_t strcat_s( char *strDestination ,uint16_t numberOfElements ,char *strSource )
{
	uint16_t len = strlen( strDestination );
	if ( len >= numberOfElements ) {
		return ( 1 );
	}

	numberOfElements -= len;
	strDestination += len;
	return ( strcpy_s( strDestination ,numberOfElements ,strSource ) );
}

uint8_t strcat_s_P( char *strDestination ,uint16_t numberOfElements ,const prog_char *strSource )
{
	uint16_t len = strlen( strDestination );
	if ( len >= numberOfElements ) {
		return ( 1 );
	}

	numberOfElements -= len;
	strDestination += len;
	return ( strcpy_s_P( strDestination ,numberOfElements ,strSource ) );
}
#endif

#if USE_STRCPY_S
/*****************************************************************************
*							Rs[(ZLeBΉ)
* Fchar *strDestination       Rs[obt@
*       uint16_t numberOfElements  obt@TCY
*       char *strSource            Rs[
* ߒlFuint8_t  0:OK !0:obt@I[o[
*****************************************************************************/
uint8_t strcpy_s( char *strDestination ,uint16_t numberOfElements ,char *strSource )
{
	char c;
	if ( numberOfElements ) {
		while ( numberOfElements-- ) {
			c = *strSource++;
			*strDestination++ = c;
			if ( c == '\0' ) {
				return ( 0 );
			}
		}
		*( strDestination - 1 ) = '\0';
	}
	return ( 1 );
}

uint8_t strcpy_s_P( char *strDestination ,uint16_t numberOfElements ,const prog_char *strSource )
{
	char c;
	if ( numberOfElements ) {
		while ( numberOfElements-- ) {
			c = pgm_read_byte( strSource++ );
			*strDestination++ = c;
			if ( c == '\0' ) {
				return ( 0 );
			}
		}
		*( strDestination - 1 ) = '\0';
	}
	return ( 1 );
}
#endif
