/*############################################################################
#                                                                            #
#   		                  DDNS NCAg								 #
#                                                                            #
############################################################################*/
#define __DDNS_C__

#include <avr/io.h>
#include <string.h>

#include "net.h"
#include "ddns.h"
#include "../etc_funcs.h"
#include "../myutil/string_func.h"

#define DEFAULT_HTTP_PORT 80

static uint32_t get_remote_ip_address( void );
static uint8_t update_ddns( void );
static uint16_t http_connect( SOCKET sok ,char *url );

/*****************************************************************************
*								DDNS
* Fvoid
* ߒlFvoid
*****************************************************************************/
void ddns_init( void )
{
	netInfo.ddnsLastCheck = 0L;
	netInfo.ddnsLastUpdate_sts = 0;
	netInfo.checkIpAddress = 0L;
}

/*****************************************************************************
*								DDNS^XN
* Fvoid
* ߒlFvoid
*****************************************************************************/
void ddns_task( void )
{
	uint32_t tim;
	uint32_t ip = 0L;
	uint8_t update_flag = 0;

	/* NTPԃ`FbN						*/
	if ( ( net_task_status() != 0xff ) || ( ntpcInfo.lastUpdate == 0L ) ) {
		return;
	}

	if ( netInfo.ddnsLastCheck > ntpcInfo.systemTime ) {
		netInfo.ddnsLastCheck = ntpcInfo.systemTime;	/* ݎɒu	*/
	}

	if ( netInfo.ddnsLastUpdate > ntpcInfo.systemTime ) {
		netInfo.ddnsLastCheck = ntpcInfo.systemTime;	/* ݎɒu	*/
	}

	/* IP`FbNTCN`FbN			*/
	tim = ntpcInfo.systemTime - netInfo.ddnsLastCheck;	/* ŏI`FbŇoߕbvZ	*/
	if ( tim < DDNS_CHECK_IP_CYCLE ) {
		return;
	}

	/* [gIP擾TCgQ				*/
	netInfo.ddnsLastCheck = ntpcInfo.systemTime;		/* ŌIP`FbNL^		*/
	ip = get_remote_ip_address();						/* [gIPAhX擾				*/
	if ( ip ) {
		netInfo.checkIpAddress = ip;					/* ŌɃ`FbNIPL				*/
		netInfo.ddnsLastCheck_sts = 1;					/* Xe[^XL^					*/

		/* DDNSXVL					*/
		if ( netInfo.ddnsMode ) {

			/* IPAhXω`FbN		*/
			if ( netInfo.ddnsLastUpdateIpAddress != ip ) {
				update_flag = 1;

			/* XVTCN`FbN		*/
			} else {
				tim = ntpcInfo.systemTime - netInfo.ddnsLastUpdate;	/* ŏIXV̌oߕbvZ*/
				if ( tim >= DDNS_COMPULSION_UPDATE_CYCLE ) {
					update_flag = 1;
				}
			}

			/* DDNSXV						*/
			if ( update_flag ) {
				netInfo.ddnsLastUpdate = ntpcInfo.systemTime;
				netInfo.ddnsLastUpdate_sts = 2;
				if ( update_ddns() == 0 ) {
					netInfo.ddnsLastUpdateIpAddress = ip;
					netInfo.ddnsLastUpdate_sts = 1;
					eep_write_netInfo();
				}
			}
		}

	} else {
		netInfo.ddnsLastCheck_sts = 2;					/* sXe[^XL^					*/
	}
}

/*****************************************************************************
*				[gIPAhXmFTCgIPAhX擾
* Fvoid
* ߒlFuint32_t 擾IPAhX
*****************************************************************************/
static uint32_t get_remote_ip_address( void )
{
	char url[ URL_SIZE ];
	uint16_t res;

	/* KURL֐ڑ				*/
	eep_read_remote_check_url( url ,sizeof(url) );
	res = http_connect( HTTPC_SOCK ,url );
	if ( res != 200 ) {
		return ( 0L );
	}

	/* f[^Ǎ					*/
	uint32_t ip = 0L;
	char msg[ 96 ];
	do {						/* `N]łMł悤ɑSs`FbN	*/
		if ( tcp_gets( HTTPC_SOCK ,sizeof(msg) ,msg ) ) {
			msg[0] = '\0';
		} else if ( ip == 0L ) {
			ip = inet_addr( msg );
			if ( ip ) {
				break;
			}
		}
	} while ( msg[0] );

	/* ؒf								*/
	tcp_disconnect( HTTPC_SOCK );

	return ( ip );
}

/*****************************************************************************
*								DDNSXV
* Fvoid
* ߒlFuint8_t 0:  !0:XVs
*****************************************************************************/
static uint8_t update_ddns( void )
{
	char url[ URL_SIZE ];
	uint16_t res;

	/* KURL֐ڑ				*/
	eep_read_ddns_update_url( url ,sizeof(url) );
	res = http_connect( HTTPC_SOCK ,url );
	if ( res != 200 ) {
		return ( 1 );
	}

	/* f[^Ǎ				*/
	char msg[ 96 ];
	uint8_t sts = 0;
	do {
		if ( tcp_gets( HTTPC_SOCK ,sizeof(msg) ,msg ) ) {
			msg[0] = '\0';
		} else {
			if ( strcasestr_P( msg ,PSTR("<title>error") ) != NULL ) {	/* G[bZ[WH(IE-SERVER)	*/
				sts = 1;
			}

			if ( strcasestr_P( msg ,PSTR("fail:") ) != NULL ) {			/* G[bZ[WH(DDO)			*/
				sts = 1;
			}
		}
	} while ( msg[0] );

	/* ؒf							*/
	tcp_disconnect( HTTPC_SOCK );

	return ( sts );
}

/*****************************************************************************
*								HTTPڑ
* FSOCKET sok \Pbgԍ
*       char *url  ڑURLi֐sɔj󂳂j
* ߒlFuint16_t   0xffff:\PbgG[ / HTTPXe[^Xԍ
*****************************************************************************/
static uint16_t http_connect( SOCKET sok ,char *url )
{
	URL u;
	uint32_t ip = 0L;

	/* URL							*/
	urlDismantled( url ,&u );
	if ( *u.domain == '\0' ) {
		return ( 0xffff );
	}

	if ( u.port == 0 ) {
		u.port = DEFAULT_HTTP_PORT;
	}

	/* DNS₢킹					*/
	if ( ( ip = gethostbyname( u.domain ) ) == 0L ) {
		return ( 0xffff );
	}

	/* HTTPT[o[ڑ					*/
	if ( tcp_connect( sok ,ip ,u.port ,Sn_MR_ND ) == 0 ) {
		return ( 0xffff );
	}

	/* NGXg						*/
	uint8_t sts = 0;
	char msg[ 256 ];

	strcpy_s_P( msg ,sizeof(msg) ,PSTR("GET ") );
	if ( u.file[0] != '/' ) {
		strcat_s_P( msg ,sizeof(msg) ,PSTR("/") );
	}
	strcat_s( msg ,sizeof(msg) ,u.file );
	if ( u.para[0] ) {
		strcat_s_P( msg ,sizeof(msg) ,PSTR("?") );
		strcat_s( msg ,sizeof(msg) ,u.para );
	}
	strcat_s_P( msg ,sizeof(msg) ,PSTR(" HTTP/1.1\r\n") );
	sts = tcp_send( HTTPC_SOCK ,msg ,strlen( msg ) );

	strcpy_s_P( msg ,sizeof(msg) ,PSTR("Host: ") );
	strcat_s( msg ,sizeof(msg) ,u.domain );
	strcat_s_P( msg ,sizeof(msg) ,PSTR("\r\n") );

	strcat_s_P( msg ,sizeof(msg) ,PSTR("\r\n") );

	if ( !sts ) {
		sts = tcp_send( sok ,msg ,strlen( msg ) );
	}

	if ( sts ) {
		tcp_disconnect( sok );
		return ( 0xffff );
	}

	/* X|X`FbN				*/
	if ( tcp_gets( sok ,sizeof(msg) ,msg ) ) {
		tcp_disconnect( sok );
		return ( 0xffff );
	}

	if ( strcasestr_P( msg ,PSTR("HTTP/1.1 ") ) != msg ) {
		tcp_disconnect( sok );
		return ( 0xffff );
	}

	uint16_t res = 0;
	if ( atou16( &msg[9] ,&res ) != 0 ) {
		tcp_disconnect( sok );
		return ( 0xffff );
	}

	/* wb_ǂݔ΂				*/
	do {
		if ( tcp_gets( HTTPC_SOCK ,sizeof(msg) ,msg ) ) {
			tcp_disconnect( HTTPC_SOCK );
			return ( 0xffff );
		}
	} while ( msg[0] );

	return ( res );
}
