/*###########################################################################
#                                                                           #
#               NetBIOS Name Service (NBNS) Server                          #
#   Ȍd`FbN͍sȂׁAKj[NȖOݒ肵Ă    #
#                                                                           #
###########################################################################*/
#define __NBNS_C__

#include <avr/io.h>
#include <string.h>
#include "net.h"
#include "../myutil/string_func.h"

#define NBNS_PORT 137					/* NBNS |[gԍ					*/

#define	NB		 0x2000
#define	NBSTAT	 0x2100
#define INTERNET 0x0100

/* NBNS vpPbg\(50Bytes)	*/
typedef struct NBT_QUE_t {
	uint16_t xid;						/* gUNVhc				*/
	uint16_t flags;						/* etO						*/
	uint16_t questions;					/* ⃌R[h					*/
	uint16_t answers;					/* R[h					*/
	uint16_t auths;						/* ЃR[h					*/
	uint16_t adds;						/* ǉR[h					*/
	uint8_t size;						/* ╶f[^				*/
	uint8_t name[33];					/* ╶						*/
	uint16_t typ;						/* ^Cv							*/
	uint16_t cls;						/* NX							*/
} NBT_QUE;

/* NBNS pPbg\(62Bytes)		*/
typedef struct NBT_ANS1_t {
	uint16_t xid;						/* gUNVhc				*/
	uint16_t flags;						/* etO						*/
	uint16_t questions;					/* ⃌R[h					*/
	uint16_t answers;					/* R[h					*/
	uint16_t auths;						/* ЃR[h					*/
	uint16_t adds;						/* ǉR[h					*/
	uint8_t size;						/* ╶f[^				*/
	uint8_t name[33];					/* ╶						*/
	uint16_t typ;						/* ^Cv							*/
	uint16_t cls;						/* NX							*/
	uint32_t timeToLive;
	uint16_t length;
	uint16_t node;
	uint32_t ip;
} NBT_ANS1;

/* NBNS pPbg\(117Bytes)	*/
typedef struct NBT_ANS2_t {
	uint16_t xid;						/* gUNVhc				*/
	uint16_t flags;						/* etO						*/
	uint16_t questions;					/* ⃌R[h					*/
	uint16_t answers;					/* R[h					*/
	uint16_t auths;						/* ЃR[h					*/
	uint16_t adds;						/* ǉR[h					*/
	uint8_t size;						/* ╶f[^				*/
	uint8_t name[33];					/* ╶						*/
	uint16_t typ;						/* ^Cv							*/
	uint16_t cls;						/* NX							*/
	uint32_t timeToLive;
	uint16_t length;
	uint8_t numberOfNames;
	uint8_t ansName[15];
	uint8_t suffix;
	uint16_t node;
	uint8_t mac[6];
	uint8_t zero[36];
} NBT_ANS2;

static void decode( uint8_t *data ,uint8_t len ,char *buf );

/*****************************************************************************
*								NBNS ^XN
* Fvoid
* ߒlFvoid
*****************************************************************************/
void nbns_task( void )
{
	uint16_t port;
	uint32_t ip;
	uint16_t len;
	char name[18];

	union {
		NBT_QUE Que;
		NBT_ANS1 Ans1;
		NBT_ANS2 Ans2;
		char buf[128];
	} u;

	/* \PbgI[v				*/
	if ( ( wiz_getSn_SR( NBNS_SOCK ) != SOCK_UDP ) || ( wiz_getSn_SPORT( NBNS_SOCK ) != NBNS_PORT ) ) {
		if ( udp_open( NBNS_SOCK ,NBNS_PORT ) != SOCK_UDP ) {
			return;
		}
	}

	/* f[^M					*/
	len = udp_recvfrom( NBNS_SOCK ,&u ,sizeof(NBT_QUE) ,&ip ,&port );
	if ( len != sizeof(NBT_QUE) ) {
		return;
	}

	if ( ( u.Que.questions != 0x0100 ) || ( u.Que.answers != 0 ) || ( u.Que.auths != 0 ) || ( u.Que.adds != 0 ) || ( u.Que.size != 32 ) || ( u.Que.cls != INTERNET ) ) {
		return;
	}

	/* l[fR[h			*/
	decode( u.Que.name ,32 ,name );
	name[15] = '\0';
	strtrim( name );

	/* bZ[W쐬			*/
	if ( u.Que.typ == NB ) {
		if ( strcasecmp( name ,netInfo.hostname ) == 0 ) {
			u.Ans1.flags = 0x0085;
			u.Ans1.questions = 0;
			u.Ans1.answers = 0x0100;
			u.Ans1.timeToLive = 0L;				/* Time To Live				*/
			u.Ans1.length = 0x0600;				/* f[^(6bytes)			*/
			u.Ans1.node = 0x0020;				/* P-Node,Unique			*/
			u.Ans1.ip = netInfo.ip;				/* NB Address				*/
			udp_sendto( NBNS_SOCK ,&u.Ans1 ,sizeof(NBT_ANS1) ,ip ,port );
		}

	} else if ( u.Que.typ == NBSTAT ) {
		if ( strcmp_P( name ,PSTR("*") ) == 0 ) {
			u.Ans2.flags = 0x0084;
			u.Ans2.questions = 0;
			u.Ans2.answers = 0x0100;
			u.Ans2.timeToLive = 0L;
			u.Ans2.length = 0x3d00;				/* f[^(61bytes)		*/
			u.Ans2.numberOfNames = 1;
			memset( u.Ans2.ansName ,' ' ,sizeof(u.Ans2.ansName) );
			memcpy( u.Ans2.ansName ,netInfo.hostname ,strlen( netInfo.hostname ) );
			u.Ans2.suffix = 0;
			u.Ans2.node = 0x0024;				/* P-Node,Unique,Active		*/
			memcpy( u.Ans2.mac ,netInfo.mac ,6 );	/* MACAhX			*/
			memset( u.Ans2.zero ,0x00 ,sizeof(u.Ans2.zero) );
			udp_sendto( NBNS_SOCK ,&u.Ans2 ,sizeof(NBT_ANS2) ,ip ,port );
		}
	}
}

/*****************************************************************************
*						ꂽfR[h
* Fuint8_t *data f[^
*		uint8_t len   f[^()
*		char    *buf  fR[hobt@(Œł len / 2 Kv )
* ߒlFvoid
*****************************************************************************/
static void decode( uint8_t *data ,uint8_t len ,char *buf )
{
	for ( uint8_t i = 0 ;i < len ;i += 2 ) {
		uint8_t h = ( *data++ - 'A' ) & 0x0f;
		uint8_t l = ( *data++ - 'A' ) & 0x0f;
		*buf++ = ( h << 4 ) + l;
	}
}
