/*###########################################################################
#                                                                           #
#                    	C[TlbgW[                          #
#                                                                           #
###########################################################################*/
#define __NET_C__

#include <avr/io.h>
#include <string.h>
#include <util/delay.h>
#include "net.h"
#include "../myutil/string_func.h"
#include "../SC1602/lcd.h"

/* lbg[NJñ^CAEg臒l	*/
#define NETWORK_SYSTEM_TIMEOUT 500			/* 10msecP					*/

/* O[oϐ				*/
NET_CONFIG netInfo;
DHCP_INFO dhcpInfo;
NTPC_INFO ntpcInfo;
WOL_INFO wolInfo;

/* [Jϐ					*/
static volatile uint16_t netTimeout = 0;	/* ^CAEgJE^			*/
static volatile uint8_t netInit = 0;		/* σtO				*/

/*****************************************************************************
*							lbg[N^XN
* Fvoid
* ߒlFvoid
*****************************************************************************/
void net_init( void )
{
	netInit = 0;
}

/*****************************************************************************
*						lbg[N^C}[(10msec)
* Fvoid
* ߒlFvoid
* Ȃׂm10msecɌĂяo
*****************************************************************************/
void net_timer( void )
{
	static uint8_t secCount = 0;

	/* DHCPNCAg^C}[(1sec)	*/
	if ( ++secCount >= 100 ) {
		secCount = 0;
		if ( dhcpInfo.ipTimer ) {
			dhcpInfo.ipTimer--;
		}
	}

	/* DHCPNCAg^C}[(10msec)	*/
	if ( dhcpInfo.timeOut && netInfo.ip ) {
		dhcpInfo.timeOut--;
	}

	/* lbg[N^CAEg^C}[		*/
	if ( netTimeout ) {
		netTimeout--;
	}

	/* NTPVXeJE^			*/
	if ( ++ntpcInfo.ms10Count >= 100 ) {
		ntpcInfo.ms10Count = 0;
		ntpcInfo.systemTime++;
	}

	/* NTPNCAg^C}[			*/
	if ( ntpcInfo.timeout ) {
		ntpcInfo.timeout--;
	}

	/*												*/
	/* WOL ^C}[								*/
	/* }WbNpPbgMɃobNCg_	*/
	/*												*/
	if ( wolInfo.blinkCount ) {
		TCCR0A = 0;											/* Timer0 PWM		*/
		TCCR0B = 0;
		if ( --wolInfo.blinkCount ) {
			if ( !( wolInfo.blinkCount % 3 ) ) {			/* 3				*/
				if ( lcdBackLightStatus() == OFF ) {		/* LCDobNCg_	*/
					lcdBackLight( ON );
				} else {
					lcdBackLight( OFF );
				}
			}

		} else {											/* _ŏI͒ʏPWM	*/
			TCCR0A = _BV(COM0A1) | _BV(COM0A0) | _BV(WGM00);
			TCCR0B = 3;
			TCNT0 = 0;
		}
	}
}

/*****************************************************************************
*							lbg[N^XN
* Fvoid
* ߒlFvoid
* C[v펞Ăт
*****************************************************************************/
void net_task( void )
{
	/* W5100 ^CAEgo			*/
	if ( ( netInit == 2 ) && ( !netTimeout ) ) {
		netInit = 0;
	}

	/* lbg[NVXe			*/
	if ( netInit == 0 ) {

		/* W5100 n[hEGAZbg		*/
		wiz_iinchip_init();
		_delay_ms( 50 );

		/* W5100 MACAhXݒ			*/
		wiz_setSHAR( netInfo.mac );

		/* W5100 \Pbgobt@ݒ		*/
		wiz_sysinit( 0x55 ,0x55 );

		/* DHCPNCAg			*/
		dhcpc_init();

		/* NTPNCAg			*/
		ntpc_init();

		/* WOLs[^				*/
		wol_init();

		/* DDNS						*/
		ddns_init();

		netTimeout = 500;						/* Zbg̑ҋ@	10msecP	*/
		netInit = 1;

	/* Zbg̑҂						*/
	} else if ( netInit == 1 ) {
		if ( !netTimeout ) {
			if ( netInfo.dhcpMode == IP_DYNAMIC ) {
				netTimeout = NETWORK_SYSTEM_TIMEOUT;
				netInit = 2;
			} else {
				char buf[ sizeof( W5100_HOST_TESTNAME ) + 1 ];
				strcpy_s_P( buf ,sizeof(buf) ,PSTR( W5100_HOST_TESTNAME ) );
				if ( gethostbyname( buf ) != 0 ) {
					netTimeout = 0;
					netInit = 0xff;
				}
			}
		}

	/* DHCPݒ芮҂						*/
	} else if ( netInit == 2 ) {
		dhcpc_task();							/* DHCPNCAg			*/
		if ( netInfo.ip ) {
			netTimeout = 0;
			netInit = 0xff;
		}

	/* eT[rX						*/
	} else {
		if ( net_task_status() == 0xff ) {		/* DHCPƔ\PbggpT[rXDHCPrW[ɂ͎sȂ	*/
			ntpc_task();						/* NTPNCAg			*/
			ddns_task();						/* DDNS						*/
		}
		dhcpc_task();							/* DHCPNCAg			*/
		https_task();							/* HTTPT[o[				*/
		nbns_task();							/* NetBiosOT[o[		*/
		wol_task();								/* WOLs[^[			*/
	}
}

/*****************************************************************************
*							lbg[NXe[^X擾
* Fvoid
* ߒlFuint8_t 0x00/0x01/0x02 : 
*				0x03           : DHCPrW[
*				0xff           : 
*****************************************************************************/
uint8_t net_task_status( void )
{
	if ( netInit == 0xff ) {
		if ( ( dhcpInfo.status != DHCP_STS_DISABLE ) && ( dhcpInfo.status != DHCP_STS_LEASED ) ) { /* DHCP-Busy?	*/
			return ( 3 );
		}
	}
	return ( netInit );
}
