/*###########################################################################
#                                                                           #
#                    	C[TlbgW[                          #
#                                                                           #
###########################################################################*/
#ifndef __NET_H__
#define __NET_H__
#include <avr/io.h>
#include "w5100.h"
#include "dhcpc.h"
#include "ntpc.h"
#include "nbns.h"
#include "dnsc.h"
#include "https.h"
#include "socket.h"
#include "net_util.h"

#include "ddns.h"
#include "wol.h"

/* W5100 DNSmFpzXg		*/
#define W5100_HOST_TESTNAME "npyo.net"

/* ʓIURLobt@TCY	*/
#define URL_SIZE 140

/* eT[rXŎgp\Pbgԍ	*/
#define NTPC_SOCK  3
#define DNSC_SOCK  3
#define HTTPC_SOCK 3

#define DHCP_SOCK  3
#define NBNS_SOCK  2
#define HTTPS_SOCK 1
#define WOL_SOCK   0

/* DHCP샂[h				*/
#define IP_STATIC  0				/* ŒIP[h								*/
#define IP_DYNAMIC 1				/* IPݒ胂[h							*/

/* lbg[Np[^\	*/
typedef struct NET_CONFIG_t {
	volatile uint32_t ip;			/* IPAhX								*/
	volatile uint32_t subnet;		/* Tulbg}XN							*/
	volatile uint32_t gateway;		/* Q[gEGCAhX						*/
	volatile uint32_t dns;			/* DNST[o[AhX						*/
	char ntpcName[ 32 ];			/* NTPT[o[							*/
	char hostname[ 16 ];			/* zXgl[(ő15)					*/
	uint8_t mac[ 6 ];				/* MACAhX								*/
	volatile uint8_t dhcpMode;		/* IP擾[h IP_STATIC / IP_DYNAMIC		*/

	/* WOLs[^[pɊg	*/
	uint16_t wolPort;				/* WOLgp|[gԍ						*/
	uint32_t checkIpAddress;		/* ŌɎ擾[gIP					*/

	/* DDNSpɊg(EEPւ̕ۑf[^͕ۏؖ)	*/
	uint32_t ddnsLastUpdateIpAddress;/* ŌDDNSXVIPAhX		*/
	uint32_t ddnsLastCheck;			/* ŌIP`FbN					*/
	uint32_t ddnsLastUpdate;		/* ŌDDNSXV					*/
	uint8_t ddnsLastCheck_sts;		/* ŌIP`FbN(0:s 1: 2:s)	*/
	uint8_t ddnsLastUpdate_sts;		/* ŌDDNSXV(0:s 1: 2:s)	*/
	uint8_t ddnsMode;				/* DDNSgpEgp(0:gp 1:gp)		*/

} NET_CONFIG;

/* O[oϐ`			*/
#ifndef __NET_C__
extern NET_CONFIG netInfo;
extern DHCP_INFO dhcpInfo;
extern NTPC_INFO ntpcInfo;
extern WOL_INFO wolInfo;
#endif

/* ֐vg^Cv錾				*/
void net_init( void );
void net_timer( void );
void net_task( void );
uint8_t net_task_status( void );

#endif
