/*############################################################################
#                                                                            #
#   		          lbg[Np[eBeB      			         #
#                                                                            #
############################################################################*/
#define __NET_UTIL_C__

#include <stdio.h>
#include <ctype.h>
#include <string.h> 
#include <avr/io.h>
#include <avr/pgmspace.h>
#include "net_util.h"
#include "../myutil/string_func.h"

#if ( USE_IS_DOMAIN == 1 )
/*****************************************************************************
*			񂪃hCƂĎgpł邩`FbN
* Fchar    *str 
* ߒlFuint8_t      0:NG 1:OK
*****************************************************************************/
uint8_t isDomain( char *str )
{
	/* 񒷃`FbN							*/
	uint16_t len = strlen( str );
	if ( len > 63 ) {
		return ( 0 );
	}

	char *p = strchr( str ,'.' );
	if ( p != NULL ) {
		len = p - str;
	}

	if ( len < 3 ) {
		return ( 0 );
	}

	/* ŏƍŌ̃nCt`FbN				*/
	if ( ( str[0] == '-' ) || ( str[len - 1] == '-' ) ) {
		return ( 0 );
	}

	/* RځESژAnCt`FbN	*/
	if ( ( str[2] == '-' ) && ( str[3] == '-' ) ) {
		return ( 0 );
	}

	/* gps`FbN						*/
	len = strlen( str );
	while ( len-- ) {
		char c = toupper( *str++ );
		if ( ( c != '.' ) && ( c != '-' ) && ( ( c < '0' ) || ( c > '9' ) ) && ( ( c < 'A' ) || ( c > 'Z' ) ) ) {
			return ( 0 );
		}
	}

	return ( 1 );
}
#endif

#if ( USE_MAC_ADDR == 1 )
/*****************************************************************************
*					MACAhXoCgzɕϊ
* Fchar    *str ( xx:xx:xx:xx:xx:xx or xx-xx-xx-xx-xx-xx )
*		uint8_t *mac MACAhXf[^(6bytes)
* ߒlFuint8_t      0:OK !0:NG
*****************************************************************************/
uint8_t mac_addr( char *str ,uint8_t *mac )
{
	uint8_t c;
	uint8_t i;
	uint8_t *p = mac;

	/* 񒷃`FbN				*/
	if ( strlen( str ) != 17 ) {
		return ( 1 );
	}

	/* ؂蕶̃`FbN			*/
	if ( ( str[2] != ':' ) || ( str[5] != ':' ) || ( str[8] != ':' ) || ( str[11] != ':' ) || ( str[14] != ':' ) ) {
		if ( ( str[2] != '-' ) || ( str[5] != '-' ) || ( str[8] != '-' ) || ( str[11] != '-' ) || ( str[14] != '-' ) ) {
			return ( 2 );
		}
	}

	/* el̃`FbN(6)		*/
	for ( i = 0 ;i < 6 ;i++ ) {
		*p = 0;

		c = toupper( *str++ );
		if ( ( c >= '0' ) && ( c <= '9' ) ) {
			c -= '0';
		} else if ( ( c >= 'A' )&& ( c <= 'F' ) ) {
			c = ( c - 'A' ) + 10;
		} else {
			return ( 3 );
		}
		*p = c << 4;

		c = toupper( *str++ );
		if ( ( c >= '0' ) && ( c <= '9' ) ) {
			c -= '0';
		} else if ( ( c >= 'A' )&& ( c <= 'F' ) ) {
			c = ( c - 'A' ) + 10;
		} else {
			return ( 4 );
		}
		*p |= c;

		p++;
		str++;
	}

	/* l`FbN				*/
	if ( ( mac[0] == 0x00 ) && ( mac[1] == 0x00 ) && ( mac[2] == 0x00 ) && ( mac[3] == 0x00 ) && ( mac[4] == 0x00 ) && ( mac[5] == 0x00 ) ) {
		return ( 5 );
	}

	if ( ( mac[0] == 0xff ) && ( mac[1] == 0xff ) && ( mac[2] == 0xff ) && ( mac[3] == 0xff ) && ( mac[4] == 0xff ) && ( mac[5] == 0xff ) ) {
		return ( 6 );
	}

	return ( 0 );
}
#endif

#if ( USE_URL_DISMANTLED == 1 )
/*****************************************************************************
*								url𕪉
* Fchar *url URL
*		URL  *u   URL̓f[^
* ߒlFvoid
*  url ̃f[^͔j󂳂
*****************************************************************************/
void urlDismantled( char *url ,URL *u )
{
	char *p;
	uint16_t len;

	/* 񒷃`FbN						*/
	len = strlen( url );
	if ( len > 255 ) {
		return;
	}

	/* URL\̏						*/
	memset( u ,0x00 ,sizeof(URL) );

	/* XL[擾							*/
	p = strstr_P( url ,PSTR("://") );
	if ( p ) {
		u->scheme = url;
		*p = '\0';
		url = p + 3;
	}

	/* hCƃ|[gԍ擾			*/
	u->domain = url;
	p = strchr( url ,':' );
	if ( p ) {
		*p++ = '\0';
		while ( *p && isDecimalNumber( *p ) ) {
			u->port *= 10;
			u->port += ( *p - '0' );
			p++;
		}
		url = p;
	}

	p = strchr( url ,'/' );
	if ( p ) {
		*p = '\0';
		url = p + 1;
	} else {
		url += strlen( url );
	}

	/* tH_{t@C擾			*/
	u->file = url;
	p = strchr( url ,'?' );
	if ( p ) {
		*p = '\0';
	}

	/* p[^擾						*/
	u->para = p + 1;
}
#endif

/*****************************************************************************
*							oCgI[_[ւ
* Fuint16_t val
* ߒlFuint16_t val
*****************************************************************************/
uint16_t swapByteorder16( uint16_t val )
{
	uint8_t b[2];
	b[1] = *(uint8_t *)&val;
	b[0] = *( (uint8_t *)&val + 1 );
	return ( *(uint16_t *)b );
}

uint32_t swapByteorder32( uint32_t val )
{
	uint8_t b[4];
	b[3] = *(uint8_t *)&val;
	b[2] = *( (uint8_t *)&val + 1 );
	b[1] = *( (uint8_t *)&val + 2 );
	b[0] = *( (uint8_t *)&val + 3 );
	return ( *(uint32_t *)b );
}

/*****************************************************************************
*							MCUZbg
* Fvoid
* ߒlFvoid
*****************************************************************************/
void mcu_soft_reset( void )
{
	asm volatile("jmp 0x0000");	
}

/*****************************************************************************
*					32bitlIPAhX\Lɕϊ
* Fchar     *str
*		uint32_t addr
* ߒlFvoid
*****************************************************************************/
void inet_ntoa( char *str ,uint32_t addr )
{
	uint8_t *ip = (uint8_t *)&addr;
	sprintf_P( str ,PSTR("%u.%u.%u.%u") ,ip[0] ,ip[1] ,ip[2] ,ip[3] );
}

/*****************************************************************************
*					IPAhXIPAhXlɕϊ
* Fchar     *addr
* ߒlFuint32_t IPl
*****************************************************************************/
uint32_t inet_addr( char *addr )
{
	uint8_t ip[4];
	uint8_t i;
	uint16_t num;
	char buf[24];
	char *p;

	/* 񒷃`FbN			*/
	if ( strlen( addr ) > 20 ) {
		return ( 0L );
	}

	/* sIh̐`FbN		*/
	strcpy( buf ,addr );
	p = buf;
	i = 0;
	while ( *p ) {
		if ( *p++ == '.' ) {
			if ( ++i > 3 ) {
				break;
			}
		}
	}

	if ( i != 3 ) {
		return ( 0L );
	}

	/* sIhɕ؂o	*/
	p = buf;
	for ( i = 0 ;i < 4 ;i++ ) {
		p = strtok_P( p ,PSTR(".") );
		if ( atou16( p ,&num ) != 0 ) {
			return ( 0L );
		}

		if ( num > 255 ) {
			return ( 0L );
		}

		ip[i] = (uint8_t)num;
		p = NULL;
	}

	return ( *(uint32_t *)ip );
}

