/*###########################################################################
#                                                                           #
#                           NTPNCAg                                 #
#                                                                           #
# Ql) http://wiki.livedoor.jp/yamamaya_com/                               #
#       http://wiki.livedoor.jp/yamamaya_com/d/NTP%bb%fe%b7%d7ver.1         #
#                                                                           #
#                                                                           #
###########################################################################*/
#define __NTPC_C__

#include <string.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include "../myutil/date.h"
#include "net.h"

#define NTPC_RETRY_TIME ( 30UL * 100LU )	/* gCԊu(30b)			*/

/* `xp^C}[`	*/
#if ( NTPC_ADJ == 1 )
#define TIMER_NUM NTPC_TIMER_NUM			/* `x␳^C}[ԍ	*/

/* ^C}[`					*/
#if ( TIMER_NUM == 1 )
#define TCCRB TCCR1B
#define TCNT  TCNT1
#elif TIMER_NUM == 3
#define TCCRB TCCR3B
#define TCNT  TCNT3
#elif TIMER_NUM == 4
#define TCCRB TCCR4B
#define TCNT  TCNT4
#elif TIMER_NUM == 5
#define TCCRB TCCR5B
#define TCNT  TCNT5
#else
#error timer number error
#endif	// #if ( TIMER_NUM == 1 )
#endif	// #if ( NTPC_ADJ == 1 )

/* gp|[gԍ				*/
#define NTPC_PORT 123

/* EWƓ{Ԃ̎	*/
#define LOCAL_TIME	( 9L * 60L * 60L )	/* GMT +09:00:00					*/

/*****************************************************************************
*								NTPC 
* Fvoid
* ߒlFvoid
*****************************************************************************/
void ntpc_init( void )
{
	static uint8_t init = 0;

	ntpcInfo.ip = 0L;
	ntpcInfo.timeout = 0L;
	ntpcInfo.lastUpdate = 0L;
	ntpcInfo.ms10Count = 0;

	if ( !init ) {
		ntpcInfo.systemTime = 0L;
		init = 1;
	}
}

/*****************************************************************************
*									␳
* Fvoid
* ߒlFvoid
*****************************************************************************/
void ntpc_task( void )
{
	/* NTPNGXgpPbg (48Bytes)	*/
	static const prog_uint8_t reqMessage[] = {
   		0xd9 ,0x00 ,0x0a ,0xf5 ,0x00 ,0x00 ,0x00 , 0x00 ,0x00 ,0x01 ,0x04 ,0x00 ,0x00 ,0x00 ,0x00 , 0x00 ,
		0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 , 0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 , 0x00 ,
		0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 , 0x00 ,0x83 ,0xaa ,0x7e ,0x80 ,0x00 ,0x00 ,0x00 , 0x00
	};

	uint16_t port;
	uint32_t ip;
	uint8_t msg[64];
	uint16_t len;

	if ( ( ntpcInfo.timeout != 0L ) || ( netInfo.ntpcName[ 0 ] == '\0' ) ) {
		return;
	}

	/* ^CAEgϐ		*/
	ntpcInfo.timeout = NTPC_RETRY_TIME;

	/* ntpT[o[IPAhX擾	*/
	if ( ntpcInfo.ip == 0L ) {
		ntpcInfo.ip = gethostbyname( netInfo.ntpcName );
		if ( ntpcInfo.ip == 0L ) {
			return;
		}
	}

	/* \PbgI[v				*/
	if ( udp_open( NTPC_SOCK ,NTPC_PORT ) != SOCK_UDP ) {
		return;
	}

	/* NGXgbZ[W쐬/	*/
	memcpy_P( msg ,reqMessage ,sizeof(reqMessage) );

	/* ԑ^C}[	*/
	#if ( NTPC_ADJ == 1 )
	TCCRB = 0;
	TCNT = 0;
	TCCRB = 0x05;	/* F_CPU / 1024 */
	#endif	// #if ( NTPC_ADJ == 1 )

	/* NGXgM				*/
	udp_sendto( NTPC_SOCK ,msg ,sizeof(reqMessage) ,ntpcInfo.ip ,NTPC_PORT );

	/* f[^M҂				*/
	uint16_t timeout = 500;
	do {
		len = udp_recvfrom( NTPC_SOCK ,msg ,sizeof(reqMessage) ,&ip ,&port );
		if ( len ) {
			break;
		}
		_delay_ms( 1 );
	} while ( --timeout );

	/* bZ[W				*/
	if ( ( len == sizeof(reqMessage) ) && ( ip == ntpcInfo.ip ) && ( port == NTPC_PORT ) ) {
		#if ( NTPC_ADJ == 1 )
			TCCRB = 0;
			uint32_t t1 ,t2;
			float t1_p, t2_p ,delay;

			t1 = swapByteorder32( *(uint32_t *)&msg[0x20] );							/* 			*/
			t1_p = (float)swapByteorder32( *(uint32_t *)&msg[0x24] ) / 4294967296.0;	/* Œ菬->float	*/

			t2 = swapByteorder32( *(uint32_t *)&msg[0x28] );							/* 			*/
			t2_p = (float)swapByteorder32( *(uint32_t *)&msg[0x2c] ) / 4294967296.0;	/* Œ菬->float	*/
		
			delay = (float)TCNT * ( 1.0 / (float)( F_CPU / 1024 ) );					/* xvZ			*/
			delay = ( delay - (float)( t2 - t1 ) + ( t2_p - t1_p ) ) / 2.0;
			if ( delay > 0 ) {
				t1_p -= delay ;
				while ( t1_p < 0 ) {
					t1_p++ ;
					t1-- ;
				}
			}
			ntpcInfo.ms10Count = (uint8_t)( t1_p / 0.01 );
			ntpcInfo.systemTime = t1 + LOCAL_TIME;

		#else		// #if ( NTPC_ADJ == 1 )
			uint32_t tim = swapByteorder32( *(uint32_t *)&msg[0x20] );				/* 			*/
			uint32_t sec = swapByteorder32( *(uint32_t *)&msg[0x24] );				/* 			*/
			sec /= 42949672UL;														/* 10msecPʎ擾	*/
			ntpcInfo.ms10Count = (uint8_t)sec;
			ntpcInfo.systemTime = tim + LOCAL_TIME;
		#endif		// #if ( NTPC_ADJ == 1 )

		ntpcInfo.lastUpdate = ntpcInfo.systemTime;
		ntpcInfo.timeout = NTPC_NEXT_TIME;
	}

	udp_close( NTPC_SOCK );
}

/*****************************************************************************
*						VXeԂ擾
* FTIME *t    ʊi[\
* ߒlFuint32_t   VXeVAl
*****************************************************************************/
uint32_t ntpc_getTime( TIME *t )
{
	uint32_t ts = ntpcInfo.systemTime;
	ntpc_setTimeStruct( ts ,t );
	return ( ts );
}

/*****************************************************************************
*						VXeԂݒ
* FTIME *t ݒ莞ԍ\
* ߒlFvoid
*****************************************************************************/
void ntpc_setTime( TIME *t )
{
	uint32_t ts = ntpc_getSerial( t );
	ntpcInfo.systemTime = ts;
	ntpcInfo.lastUpdate = ts;
	ntpcInfo.ms10Count = 0;
}

/*****************************************************************************
*						NTPŏI擾
* FTIME *t    ʊi[\
* ߒlFuint32_t   VAl
*****************************************************************************/
uint32_t ntpc_getLastUpdate( TIME *t )
{
	uint32_t ts =  ntpcInfo.lastUpdate;
	ntpc_setTimeStruct( ts ,t );
	return ( ts );
}

/*****************************************************************************
*					ԍ\̂̃f[^ԃVAlɕϊ
* FTIME *t  ԍ\
* ߒlFuint32_t ԃVAl
*****************************************************************************/
uint32_t ntpc_getSerial( TIME *t )
{
	uint32_t sn = (uint32_t)t->hour * 3600UL;
	sn += ( (uint32_t)t->minute * 60UL );
	sn += (uint32_t)t->second;

	uint32_t mjd = date_greg2mjd( t->year ,t->month ,t->day );
	sn += ( ( mjd - 15020LU ) * 86400LU );

	return ( sn );
}

/*****************************************************************************
*						ԃVAlԍ\̂ɃZbg
* Fuint32_t  ts ԃVAl
*		TIME      *t ʊi[\
* ߒlFvoid
*****************************************************************************/
void ntpc_setTimeStruct( uint32_t ts ,TIME *t )
{ 
	/* vZ						*/
	uint32_t secs = ts % 86400L;		/* 00:00:00 ̌oߕbvZ		*/
	t->hour = (uint8_t)( secs / 3600L );
	secs %= 3600L;
	t->minute = (uint8_t)( secs / 60L );
	t->second = (uint8_t)( secs % 60L );

	/* tvZ						*/
	uint32_t days = ts / 86400L;		/* 1900/01/01 ̌oߓvZ	*/
	days += 15020LU;					/* CEXɕϊ				*/
	date_mjd2greg( days ,&t->year ,&t->month ,&t->day ,&t->wday );
}
