/*###########################################################################
# W5100                                                                     #
#        				\Pbg[eBeB								#
#        				TCP/UDP݂̂ɑΉ									#
#                                                                           #
###########################################################################*/
#define __SOCKET_C__

#include <string.h> 
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include "net_util.h"
#include "w5100.h"
#include "socket.h"

/* [J֐vg^Cv錾	*/
#if ( USE_TCP_SOCKET == 1 )
static uint8_t _tcp_send( SOCKET sok ,uint16_t buf ,uint16_t len ,cpy_t fn );
static void _tcp_recv( SOCKET sok ,uint16_t buf ,uint16_t len ,cpy_t fn );
#endif

static uint8_t isSendOK( SOCKET sok );
static uint16_t get_auto_sport( void );
static void sok_write_data( SOCKET s, uint16_t wp ,uint16_t buf ,uint16_t len ,cpy_t fn );
static void sok_read_data( SOCKET s ,uint16_t rp ,uint16_t buf ,uint16_t len ,cpy_t fn );

/*****************************************************************************
*@UDPp
*							UDP\PbgI[v
* FSOCKET   sok
*       uint16_t port |[gԍ( PORT_AUTO : ̔ j
* ߒlFuint8_t       \PbgXe[^X
*****************************************************************************/
uint8_t udp_open( SOCKET sok ,uint16_t port )
{
	if ( port == 0 ) {
		port = get_auto_sport();
	}

	udp_close( sok );
	wiz_setSn_MR( sok ,Sn_MR_UDP );
	wiz_setSn_SPORT( sok ,port );
	wiz_sockCommand( sok ,Sn_CR_OPEN );

	return ( wiz_getSn_SR( sok ) );
}

/*****************************************************************************
*@UDPp
*							UDP\PbgN[Y
* FSOCKET sok \Pbgԍ
* ߒlFvoid
*****************************************************************************/
void udp_close( SOCKET sok )
{
	wiz_sockCommand( sok ,Sn_CR_CLOSE );	/* \PbgN[Y				*/
	wiz_setSnIR( sok ,0xff );				/* ݃tONA			*/
}

/*****************************************************************************
*@UDPp
*								UDP\Pbg֑M
* FSOCKET   sok    \Pbgԍ
*       void     *buf   Mf[^
*       uint16_t len    Mf[^
*		uint8_t  *ip    MIPAhX
*       uint16_t port   M|[gԍ
* ߒlFuint8_t         0:OK !0:NG
*****************************************************************************/
uint8_t udp_sendto( SOCKET sok ,void *buf ,uint16_t len ,uint32_t ip ,uint16_t port )
{
	uint16_t wp;
	uint8_t ret;

	ret = 1;
	if ( ( wiz_getSn_SR( sok ) == SOCK_UDP ) && ( wiz_getSn_TX_FSR( sok ) >= len ) ) {

		/* MZbg					*/
		wiz_setSn_DIPR( sok ,(uint8_t *)&ip );
		wiz_setSn_DPORT( sok ,port );

		/* Ms					*/
		wp = wiz_getSn_TX_WR( sok );
		sok_write_data( sok ,wp ,(uint16_t)buf ,len ,(cpy_t)wiz_memcpy );
		wp += len;
		wiz_setSn_TX_WR( sok ,wp );
		wiz_setSnIR( sok ,Sn_IR_SEND_OK );
		wiz_sockCommand( sok ,Sn_CR_SEND );

		/* MI҂				*/
		ret = isSendOK( sok );
	}

	return ( ret );
}

/*****************************************************************************
*@UDPp
*							UDP\PbgւM
* FSOCKET   sok    \Pbgԍ
*       void     *buf   Mf[^
*       uint16_t size   Mobt@TCY
*		uint8_t  *addr  bZ[W𑗐MT[o[IPAhX
*		uint16_t *port	bZ[W𑗐MT[o[|[gԍ
* ߒlFuint16_t        pPbgTCY
* Mobt@TCY𒴂f[^͐؂̂Ă
*****************************************************************************/
uint16_t udp_recvfrom( SOCKET sok ,void *buf ,uint16_t size ,uint32_t *ip ,uint16_t *port )
{
	uint8_t h[8];
	uint16_t rp;
	uint16_t udpSize = 0;
	uint16_t recvLen = 0;

	if ( wiz_getSn_SR( sok ) == SOCK_UDP ) {

		recvLen = wiz_getSn_RX_RSR( sok );
		if ( recvLen >= 8 ) {					/*  ŒłUDPwb_MĂH	*/

			/* UDPwb_擾					*/
			rp = wiz_getSn_RX_RD( sok );
			sok_read_data( sok ,rp ,(uint16_t)h ,8 ,(cpy_t)memcpy_WIZ );
			*ip = *(uint32_t *)&h[0];
			*port =  swapByteorder16( *(uint32_t *)&h[4] );
			udpSize = swapByteorder16( *(uint32_t *)&h[6] );
			rp += 8;

			/* f[^擾(璷j*/
			if ( recvLen >= ( udpSize + 8 ) ) {
				if ( udpSize < size ) {
					size = udpSize;
				}

				if ( size ) {
					sok_read_data( sok ,rp ,(uint16_t)buf ,size ,(cpy_t)memcpy_WIZ );
				}

				rp += udpSize;
				wiz_setSn_RX_RD( sok ,rp );
				wiz_sockCommand( sok ,Sn_CR_RECV );
			}
		}
	}

	return ( udpSize );
}

#if ( USE_TCP_SOCKET == 1 )

#if USE_TCP_CONNECT_WITHOUT_WAIT
/*****************************************************************************
*@TCP/NCAgp
*					T[o[֐ڑJniڑ҂j
* FSOCKET   sok   \Pbgԍ
*       uint32_t ip    ڑIPAhX
*       uint16_t port  ڑ|[gԍ(HTTPT[o[ւ̐ڑ͒ʏ 80 )
*		uint8_t  flag  IvVtO(
* ߒlFuint8_t        \PbgXe[^X
*****************************************************************************/
uint8_t tcp_connect_without_wait( SOCKET sok ,uint32_t ip ,uint16_t port ,uint8_t flag )
{
	uint8_t sts;
	uint16_t sport;

	tcp_disconnect( sok );
	
	/* p[^`FbN			*/
	if ( ( ip == 0x00000000 ) || ( ip == 0xffffffff ) || ( port == 0 ) ) {
		return ( SOCK_CLOSED );
	}

	/* \PbgI[v				*/
	sport = get_auto_sport();
	wiz_setSn_MR( sok ,Sn_MR_TCP | flag );		/* \PbgI[v			*/
	wiz_setSn_SPORT( sok ,get_auto_sport() );
	wiz_sockCommand( sok ,Sn_CR_OPEN );

	sts = wiz_getSn_SR( sok );					/* Xe[^X擾			*/
	if ( sts != SOCK_INIT ) {
		return ( sts );
	}

	/* ڑJn						*/
	wiz_setSn_DIPR( sok ,(uint8_t *)&ip );		/* ڑIPAhXZbg	*/
	wiz_setSn_DPORT( sok ,port );				/* ڑ|[gԍZbg	*/
	wiz_sockCommand( sok ,Sn_CR_CONNECT );		/* ڑJnR}h			*/

	return ( wiz_getSn_SR( sok ) );
}
#endif

#if USE_TCP_CONNECT
/*****************************************************************************
*@TCP/NCAgp
*							T[o[֐ڑiڑ҂Lj
* FSOCKET   sok   \Pbgԍ
*       uint32_t ip    ڑIPAhX
*       uint16_t port  ڑ|[gԍ(HTTPT[o[ւ̐ڑ͒ʏ 80 )
*		uint8_t  flag  IvVtO(
* ߒlFuint8_t        \PbgXe[^X
*****************************************************************************/
uint8_t tcp_connect( SOCKET sok ,uint32_t ip ,uint16_t port ,uint8_t flag )
{
	uint8_t sts;
	uint16_t timeout = 2000;				/* ڑ^CAEg(msecP)	*/

	/* ڑJn						*/
	tcp_connect_without_wait( sok ,ip ,port ,flag );

	/* ڑ҂					*/
	while ( 1 ) {
		sts = wiz_getSn_SR( sok );
		if ( ( sts == SOCK_ESTABLISHED ) || ( sts == SOCK_CLOSED ) ) {
			break;
		}

		if ( !--timeout ) {
			tcp_disconnect( sok );
			sts = SOCK_CLOSED;
			break;
		}
		_delay_ms( 1 );
	}

	return ( sts );
}
#endif

#if USE_TCP_ISACCEPT
/*****************************************************************************
*@TCP/T[o[p
*						NCAg̐ڑԂmF
* FSOCKET   sok  \Pbgԍ
*		uint16_t port |[gԍ
* ߒlFuint8_t       0:ڑ 1:ڑL
*****************************************************************************/
uint8_t tcp_isAccept( SOCKET sok ,uint16_t port )
{
	/* \PbgXe[^XmF	*/
	uint8_t sts = wiz_getSn_SR( sok );
	if ( ( sts == SOCK_CLOSED ) || ( ( sts == SOCK_CLOSE_WAIT ) && !wiz_getSn_RX_RSR( sok ) ) ) {

		/* CLOSEȊOȂ狭Ń\PbgN[Y	*/
		if ( sts != SOCK_CLOSED ) {
			wiz_sockCommand( sok ,Sn_CR_CLOSE );
			wiz_setSnIR( sok ,0xff );					/* ݃tONA	*/
		}

		/* \PbgI[v							*/
		wiz_setSn_MR( sok ,Sn_MR_TCP );
		wiz_setSn_SPORT( sok ,port );
		wiz_sockCommand( sok ,Sn_CR_OPEN );

		/* ҂󂯏Ԃɐݒ						*/
		wiz_sockCommand( sok ,Sn_CR_LISTEN );
	}

	return( tcp_isConnected( sok ) && wiz_getSn_RX_RSR( sok ) );
}
#endif

#if USE_TCP_SENDKEEPALIVE
/*****************************************************************************
*@TCP/NCAgp
*					\PbgKeepAlivebZ[W𑗐M
* FSOCKET   sok   \Pbgԍ
* ߒlFvoid
*****************************************************************************/
void tcp_sendKeepAlive( SOCKET sok )
{
	wiz_sockCommand( sok ,Sn_CR_SEND_KEEP );
}
#endif

#if USE_TCP_ISCONNECTED
/*****************************************************************************
*@TCP/NCAgp
*							\Pbgڑ`FbN
* FSOCKET sok  \Pbgԍ
* ߒlFuint8_t     0:ڑ !0:ڑ
*****************************************************************************/
uint8_t tcp_isConnected( SOCKET sok )
{
    uint8_t sts = wiz_getSn_SR( sok );
	uint8_t ret = ( sts == SOCK_LISTEN ) || ( sts == SOCK_CLOSED ) || ( sts == SOCK_FIN_WAIT ) ||
				  ( sts == SOCK_CLOSE_WAIT && !wiz_getSn_RX_RSR( sok ) );
	return ( !ret );
}
#endif

#if USE_TCP_DISCONNECT
/*****************************************************************************
*@TCP/T[o[ENCAg
*							ڑؒf
* FSOCKET   sok  \Pbgԍ
* ߒlFvoid
*****************************************************************************/
void tcp_disconnect( SOCKET sok )
{
	uint16_t timeout = 1500;

	if ( tcp_isConnected( sok ) != 0 ) {
		wiz_sockCommand( sok ,Sn_CR_DISCON );
		while ( timeout-- && wiz_getSn_SR( sok ) != SOCK_CLOSED ) {
			_delay_ms( 1 );
		}
	}
	wiz_sockCommand( sok ,Sn_CR_CLOSE );
	wiz_setSnIR( sok ,0xff );
}
#endif

/****************************************************************************
*@TCP/T[o[ENCAg
*					Mobt@PoCg擾(M҂)
* FSOCKET  sok  \Pbgԍ
*		uint8_t *dat Mf[^i[obt@
* ߒlFuint8_t      0:OK 1:socket disconnect 2:notrecv
****************************************************************************/
uint8_t tcp_getc_without_wait( SOCKET sok ,uint8_t *dat )
{
	uint16_t rp;
	uint16_t rd_mask;
	uint16_t rd_ptr;

	*dat = 0;
	if ( !tcp_isConnected( sok ) ) {
		return ( 1 );
	}

	if ( !wiz_getSn_RX_RSR( sok ) ) {
		return ( 2 );
	}

	rp = wiz_getSn_RX_RD( sok );
	rd_mask = rp & wiz_getIINCHIP_RxMASK( sok );
	rd_ptr = wiz_getIINCHIP_RxBASE( sok ) + rd_mask;
	*dat = wiz_read_byte( rd_ptr );
	wiz_setSn_RX_RD( sok ,++rp );
	wiz_sockCommand( sok ,Sn_CR_RECV );

	return ( 0 );
}

/****************************************************************************
*@TCP/T[o[ENCAg
*							Mobt@PoCg擾
* FSOCKET  sok  \Pbgԍ
*		uint8_t *dat Mf[^i[obt@
* ߒlFuint8_t      0:OK 1:socket disconnect
****************************************************************************/
uint8_t tcp_getc( SOCKET sok ,uint8_t *dat )
{
	uint8_t ret;

	*dat = 0;

	/* 1oCgM҂					*/
	uint16_t timeout = 4000;
	do {
		ret = tcp_getc_without_wait( sok ,dat );
		if ( ret == 0 ) {
			break;
		} else if ( ret == 1 ) {
			ret = 1;
			break;
		}
		_delay_ms( 1 );
	} while ( --timeout );

	return ( ret );
}

/****************************************************************************
*@TCP/T[o[ENCAg
*							Mobt@1s擾
* FSOCKET   sok  \Pbgԍ
*		uint16_t size obt@TCY
*		char     *str obt@
* ߒlFuint8_t       0:OK
*                     1:^CAEg
*                     2:sR[hMłȂ
*
* R[hɉsR[h'\n'vM_łPsƂ
*   obt@ɂ͉sR[h͊܂܂ȂB(ŝݎMꍇA񒷂0j
****************************************************************************/
uint8_t tcp_gets( SOCKET sok ,uint16_t size ,char *str )
{
	uint8_t ret;
	uint8_t c;
	uint16_t limit = 8192;

	while ( --limit ) {
		ret = tcp_getc( sok ,&c );
		if ( ret || ( c == '\n' ) ) break;

		if ( ( c >= 0x20 ) && ( size > 1 ) ) {
			*str++ = c;
			size--;
		}
	}

	*str = '\0';							/* I[R[hZbg	*/

	if ( limit == 0 ) {
		ret = 2;
	}

	return ( ret );
}

#if WIZ_USE_SPI_SRAM
/****************************************************************************
*@TCP/T[o[ENCAg
*							Mobt@1s擾(SPI-SRAM)
* FSOCKET   sok  \Pbgԍ
*		uint16_t size obt@TCY
*		SSMP     str  obt@
* ߒlFuint8_t       0:OK
*                     1:^CAEg
*                     2:sR[hMłȂ
*
* R[hɉsR[h'\n'vM_łPsƂ
*   obt@ɂ͉sR[h͊܂܂ȂB(ŝݎMꍇA񒷂0j
****************************************************************************/
uint8_t tcp_ss_gets( SOCKET sok ,uint16_t size ,SSMP str )
{
	uint8_t ret;
	uint8_t c;
	uint16_t limit = 8192;

	while ( --limit ) {
		ret = tcp_getc( sok ,&c );
		if ( ret || ( c == '\n' ) ) break;

		if ( ( c >= 0x20 ) && ( size > 1 ) ) {
			ss_write_byte( str++ ,c );
			size--;
		}
	}

	ss_write_byte( str ,'\0' );					/* I[R[hZbg	*/

	if ( limit == 0 ) {
		ret = 2;
	}

	return ( ret );
}

#endif

/*****************************************************************************
*@TCP/T[o[ENCAg
*						\Pbgobt@f[^擾
* FSOCKET   sok \Pbgԍ
*       void    *buf Mobt@
*       uint16_t len 擾f[^
* ߒlFuint8_t      0:OK !0:NG
* Mf[^̗LɊւ炸Ƀf[^擾̂ŎOɎMf[^𒲂ׂ邱
*****************************************************************************/
void tcp_recv( SOCKET sok ,void *buf ,uint16_t len )
{
	return ( _tcp_recv( sok ,(uint16_t)buf ,len ,(cpy_t)memcpy_WIZ ) );
}

#if WIZ_USE_SPI_SRAM
/*****************************************************************************
*@TCP/T[o[ENCAg
*						\Pbgobt@f[^擾
* FSOCKET   sok \Pbgԍ
*       SSMP     buf Mobt@
*       uint16_t len 擾f[^
* ߒlFuint8_t      0:OK !0:NG
* Mf[^̗LɊւ炸Ƀf[^擾̂ŎOɎMf[^𒲂ׂ邱
*****************************************************************************/
void tcp_ss_recv( SOCKET sok ,SSMP buf ,uint16_t len )
{
	return ( _tcp_recv( sok ,(uint16_t)buf ,len ,(cpy_t)ss_memcpy_WIZ ) );
}
#endif

/*****************************************************************************
*@TCP/T[o[ENCAg
*						f[^\Pbg֑M(C)
* FSOCKET   sok \Pbgԍ
*       void    *buf Mf[^
*       uint16_t len Mf[^
* ߒlFuint8_t      0:OK !0:NG
*****************************************************************************/
uint8_t tcp_send( SOCKET sok ,void *buf ,uint16_t len )
{
	return ( _tcp_send( sok ,(uint16_t)buf ,len ,(cpy_t)wiz_memcpy ) );
}

/*****************************************************************************
*@TCP/T[o[ENCAg
*						f[^\Pbg֑M(R[ḧ)
* FSOCKET           sok \Pbgԍ
*       const prog_void *buf Mf[^
*       uint16_t         len Mf[^
* ߒlFuint8_t          0:OK !0:NG
*****************************************************************************/
uint8_t tcp_send_P( SOCKET sok ,const prog_void *buf ,uint16_t len )
{
	return ( _tcp_send( sok ,(uint16_t)buf ,len ,(cpy_t)wiz_memcpy_P ) );
}

#if WIZ_USE_SPI_SRAM
/*****************************************************************************
*@TCP/T[o[ENCAg
*						f[^\Pbg֑MiSPI-SRAMj
* FSOCKET   sok \Pbgԍ
*       SSMP     buf Mf[^
*       uint16_t len Mf[^
* ߒlFuint8_t      0:OK !0:NG
*****************************************************************************/
uint8_t tcp_send_SS( SOCKET sok ,SSMP buf ,uint16_t len )
{
	return ( _tcp_send( sok ,(uint16_t)buf ,len ,(cpy_t)wiz_memcpy_SS ) );
}
#endif

/*****************************************************************************
*			tcp_send() / tcp_send_P() / tcp_send_SS() ֐̎
* FSOCKET   sok \Pbgԍ
*       uint16_t buf Mf[^ւ̃|C^
*       uint16_t len Mf[^
*		cpy_t    fn  ubNRs[֐ւ̃|C^
* ߒlFuint8_t      0:OK !0:NG
*****************************************************************************/
static uint8_t _tcp_send( SOCKET sok ,uint16_t buf ,uint16_t len ,cpy_t fn )
{
	uint16_t wp;
	uint16_t n;
	uint16_t TxMAX  = wiz_getIINCHIP_TxMAX( sok );
	uint16_t txFree = 0;
	uint8_t ret = 0;
	uint8_t sts;

	while ( len && !ret ) {

		/* Mobt@󂫑҂		*/
		uint16_t timeout = 2500;
		do {
			sts = wiz_getSn_SR( sok );
			if ( sts != SOCK_ESTABLISHED ) {
				break;
			}

			txFree = wiz_getSn_TX_FSR( sok );
			if ( ( txFree >= len ) || ( txFree == TxMAX ) ) {
				break;
			}
			_delay_ms( 1 );
		} while ( --timeout );

		/* ^CAEg`FbN		*/
		if ( sts != SOCK_ESTABLISHED ) {
			return ( 1 );
		}

		if ( ( txFree < len ) && ( txFree != TxMAX ) ) {
			ret = 2;
			break;
		}

		/* MoCgv		*/
		if ( len <= txFree ) {
			n = len;
		} else {
			n = txFree;
		}

		/* Mobt@		*/
		wp = wiz_getSn_TX_WR( sok );
		sok_write_data( sok ,wp ,buf ,n ,fn );
		buf += n;

		/* Ms					*/
		wp += n;
		wiz_setSn_TX_WR( sok ,wp );
		wiz_setSnIR( sok ,Sn_IR_SEND_OK );
		wiz_sockCommand( sok ,Sn_CR_SEND );

		/* MI҂						*/
		ret = isSendOK( sok );
		len -= n;
	}

	return ( ret );
}

/*****************************************************************************
*					tcp_recv() / tcp_recv_SS() ֐̎
* FSOCKET   sok \Pbgԍ
*       uint16_t buf Mf[^ւ̃|C^
*       uint16_t len 擾f[^
*		cpy_t    fn  ubNRs[֐ւ̃|C^
* ߒlFvoid
*****************************************************************************/
static void _tcp_recv( SOCKET sok ,uint16_t buf ,uint16_t len ,cpy_t fn )
{
	uint16_t rp = wiz_getSn_RX_RD( sok );
	sok_read_data( sok ,rp ,buf ,len ,fn );
	rp += len;
	wiz_setSn_RX_RD( sok ,rp );
	wiz_sockCommand( sok ,Sn_CR_RECV );
}

#endif	//#if ( USE_TCP_SOCKET == 1 )

/*****************************************************************************
*							M҂
* FSOCKET sok \Pbgԍ
* ߒlFuint8_t 0:OK !0:NG
*****************************************************************************/
static uint8_t isSendOK( SOCKET sok )
{
	uint8_t ret = 1;

	uint16_t timeout = 2500;
	while ( timeout-- ) {
		if ( wiz_getSnIR( sok ) & Sn_IR_SEND_OK ) {
			ret = 0;
			break;
		}
		_delay_ms( 1 );
	}
	wiz_setSnIR( sok ,Sn_IR_SEND_OK );

	return ( ret );
}

/*****************************************************************************
*							|[gԍ擾
* Fvoid
* ߒlFuint16_t
*****************************************************************************/
static uint16_t get_auto_sport( void )
{
	static uint16_t _sport = 2048;

	uint16_t port = _sport++;
	if ( _sport >= 65530U ) {
		_sport = 2048;
	}

	return ( port );
}

/*****************************************************************************
*				\PbgMOobt@փf[^
* FSOCKET   sok  \Pbgԍ
*       uint16_t wp   Cg|Cg(Sn_TX_WR)
*		uint16_t buf  ݃f[^̈
*		uint16_t len  ݃f[^
*		cpy_t    fn   ubNRs[֐ւ̃|C^
* ߒlFvoid
*****************************************************************************/
static void sok_write_data( SOCKET sok, uint16_t wp ,uint16_t buf ,uint16_t len ,cpy_t fn )
{
	uint16_t TxMASK = wiz_getIINCHIP_TxMASK( sok );
	uint16_t TxMAX  = wiz_getIINCHIP_TxMAX( sok );
	uint16_t TxBASE = wiz_getIINCHIP_TxBASE( sok );
	uint16_t tx_mask = wp & TxMASK;
	uint16_t tx_ptr = TxBASE + tx_mask;

	if ( ( tx_mask + len ) > TxMAX ) {
		uint16_t size = TxMAX - tx_mask;
		fn( tx_ptr ,buf ,size );
		buf += size;
		size = len - size;
		fn( TxBASE ,buf ,size );
	} else {
		fn( tx_ptr ,buf ,len );
	}
}

/*****************************************************************************
*					\PbgMOobt@ǂݍ
* FSOCKET   sok  \Pbgԍ
*       uint16_t rp   [h|Cg(Sn_RX_RD)
*		uint16_t buf  f[^ǂݍݗ̈
*		uint16_t len  f[^ǂݍݐ
*		cpy_t    fn   ubNRs[֐ւ̃|C^
* ߒlFvoid
*****************************************************************************/
static void sok_read_data( SOCKET sok ,uint16_t rp ,uint16_t buf ,uint16_t len ,cpy_t fn )
{
	uint16_t RxMASK = wiz_getIINCHIP_RxMASK( sok );
	uint16_t RxMAX  = wiz_getIINCHIP_RxMAX( sok );
	uint16_t RxBASE = wiz_getIINCHIP_RxBASE( sok );
	uint16_t rd_mask = rp & RxMASK;
	uint16_t rd_ptr = RxBASE + rd_mask;

	if ( ( rd_mask + len ) > RxMAX ) {
		uint16_t size = RxMAX - rd_mask;
		fn( buf ,rd_ptr ,size );
		buf += size;
		size = len - size;
		fn( buf ,RxBASE ,size );
	} else {
		fn( buf ,rd_ptr ,len );
	}
}
