/*###########################################################################
# W5100                                                                     #
#        				\Pbg[eBeB								#
#                                                                           #
###########################################################################*/
#ifndef __SOCKET_H__
#define __SOCKET_H__

#include <avr/io.h>
#include "w5100.h"

#define USE_TCP_SOCKET 1	/* 0:TCP\Pbggp  1:TCP\Pbggp		*/
#define USE_TCP_CONNECT_WITHOUT_WAIT 1
#define USE_TCP_CONNECT 1
#define USE_TCP_ISACCEPT 1
#define USE_TCP_SENDKEEPALIVE 0
#define USE_TCP_ISCONNECTED 1
#define USE_TCP_DISCONNECT 1

#define PORT_AUTO 0

/* sok_write_data() / sok_read_data()֐p̃ubN]֐	*/
typedef void (*cpy_t)( uint16_t ,uint16_t ,uint16_t );

/* ֐vg^Cv錾				*/
uint8_t udp_open( SOCKET sok ,uint16_t port );
void udp_close( SOCKET sok );
uint8_t udp_sendto( SOCKET sok ,void *buf ,uint16_t len ,uint32_t ip ,uint16_t port );
uint16_t udp_recvfrom( SOCKET s ,void *buf ,uint16_t size ,uint32_t *ip ,uint16_t *port );

uint8_t tcp_connect_without_wait( SOCKET sok ,uint32_t ip ,uint16_t port ,uint8_t flag );
uint8_t tcp_connect( SOCKET sok ,uint32_t ip ,uint16_t port ,uint8_t flag );
uint8_t tcp_isAccept( SOCKET sok ,uint16_t port );
void tcp_sendKeepAlive( SOCKET sok );
uint8_t tcp_isConnected( SOCKET sok );
void tcp_disconnect( SOCKET sok );
uint8_t tcp_getc_without_wait( SOCKET sok ,uint8_t *dat );
uint8_t tcp_getc( SOCKET sok ,uint8_t *dat );
uint8_t tcp_gets( SOCKET sok ,uint16_t size ,char *str );
void tcp_recv( SOCKET sok ,void *buf ,uint16_t len );
uint8_t tcp_send( SOCKET sok ,void *buf ,uint16_t len );
uint8_t tcp_send_P( SOCKET sok ,const prog_void *buf ,uint16_t len );

#if WIZ_USE_SPI_SRAM
#include "../23k256/23k256.h"
void tcp_ss_recv( SOCKET sok ,SSMP buf ,uint16_t len );
uint8_t tcp_ss_gets( SOCKET sok ,uint16_t size ,SSMP str );
uint8_t tcp_send_SS( SOCKET sok ,SSMP buf ,uint16_t len );
#endif

#endif
