/*###########################################################################
#                                                                           #
#                       WIZ W5100 䃂W[                            #
#																			#
#                             WIZЌJ́uW5100 driver v1.5vx[X      #
#												          PPPOE͖T|[g #
#                                                                           #
#  W5100݂̊gpꍇAVRINTn֐ڑ(PCINT͖Ή)          #
#                                                                           #
#                            2012/11/27 SPI[hł̃oCg[h̃oOC #
###########################################################################*/
#define __W5100_C__

#include <stdio.h>
#include <string.h>
#include <avr/io.h> 
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include "w5100.h"

#define DEBUG 0				/* 0:ʏ !0:Wo͂ɃfobNo		*/

/* ݎgp^gp	*/
#if ( __DEF_IINCHIP_INT__ >= 0 ) && ( __DEF_IINCHIP_INT__ <= 7 )
#define __USE_IINCHIP_INT__ 1
#else
#define __USE_IINCHIP_INT__ 0
#endif

/* MCU݋E֎~		*/
#if __USE_IINCHIP_INT__ 
#define ENABLE_ISR()  { EIMSK |=  _BV( __DEF_IINCHIP_INT__ ); }
#define DISABLE_ISR() { EIMSK &= ~_BV( __DEF_IINCHIP_INT__ ); }
#else
#define ENABLE_ISR()
#define DISABLE_ISR()
#endif

#if ( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_SPI_MODE__ )

/* SPI[hpSCS|[g`	*/
#define SPI_SCS_DDR  ( *(volatile uint8_t *)( &SPI_SCS_PIN + 0x01 ) )
#define SPI_SCS_PORT ( *(volatile uint8_t *)( &SPI_SCS_PIN + 0x02 ) )
#define IINCHIP_ENABLE_CS()  { SPI_SCS_PORT &= ~_BV( SPI_SCS_BIT ); }	/* SPI-SCSLݒ}N	*/
#define IINCHIP_DISABLE_CS() { SPI_SCS_PORT |=  _BV( SPI_SCS_BIT ); }	/* CSݒ}N			*/

#endif

/* #RESET `				*/
#define W5100_RESET_DDR  ( *(volatile uint8_t *)( &W5100_RESET_PIN + 0x01 ) )
#define W5100_RESET_PORT ( *(volatile uint8_t *)( &W5100_RESET_PIN + 0x02 ) )
#define IINCHIP_ENABLE_RESET()  { W5100_RESET_PORT &= ~_BV( W5100_RESET_BIT ); }
#define IINCHIP_DISABLE_RESET() { W5100_RESET_PORT |=  _BV( W5100_RESET_BIT ); }

/* [Jϐ錾			*/
static uint16_t SMASK[ MAX_SOCK_NUM ];				/* Variable for Tx buffer MASK in each channel	*/
static uint16_t RMASK[ MAX_SOCK_NUM ];				/* Variable for Rx buffer MASK in each channel	*/
static uint16_t SSIZE[ MAX_SOCK_NUM ];				/* Max Tx buffer size by each channel			*/
static uint16_t RSIZE[ MAX_SOCK_NUM ];				/* Max Rx buffer size by each channel			*/
static uint16_t SBUFBASEADDRESS[ MAX_SOCK_NUM ];	/* Tx buffer base address by each channel		*/
static uint16_t RBUFBASEADDRESS[ MAX_SOCK_NUM ];	/* Rx buffer base address by each channel		*/

#if __USE_IINCHIP_INT__
static volatile uint8_t I_STATUS[ MAX_SOCK_NUM ];	/* ݂ɂXe[^Xobt@				*/
#endif

/*****************************************************************************
*								ݏ
*****************************************************************************/
#if ( __DEF_IINCHIP_INT__ >= 0 ) && ( __DEF_IINCHIP_INT__ <= 7 )
#if ( __DEF_IINCHIP_INT__ == 0 )
ISR( INT0_vect )
#elif ( __DEF_IINCHIP_INT__ == 1 )
ISR( INT1_vect )
#elif ( __DEF_IINCHIP_INT__ == 2 )
ISR( INT2_vect )
#elif ( __DEF_IINCHIP_INT__ == 3 )
ISR( INT3_vect )
#elif ( __DEF_IINCHIP_INT__ == 4 )
ISR( INT4_vect )
#elif ( __DEF_IINCHIP_INT__ == 5 )
ISR( INT5_vect )
#elif ( __DEF_IINCHIP_INT__ == 6 )
ISR( INT6_vect )
#elif ( __DEF_IINCHIP_INT__ == 7 )
ISR( INT7_vect )
#endif
{
	uint8_t ir;
	uint8_t i;

	ir = wiz_read_byte( IR );
	while ( ir ) {

		if ( ir & IR_CONFLICT ) {
			#if DEBUG
			puts_P( PSTR("IP conflict !!") );
			#endif
		}

		if ( ir & IR_UNREACH ) {
			#if DEBUG
			printf_P( PSTR("INT Port Unreachable : 0x%02x(%u)\n") ,int_val );
			printf_P( PSTR("UIPR0  : 0x%02x 0x%02x 0x%02x 0x%02x ( %u.%u.%u.%u )\n") ,wiz_read_byte( UIPR0 ) ,wiz_read_byte( UIPR0 + 1 ) ,wiz_read_byte( UIPR0 + 2 ) ,wiz_read_byte( UIPR0 + 3 ) ,wiz_read_byte( UIPR0 ) ,wiz_read_byte( UIPR0 + 1 ) ,wiz_read_byte( UIPR0 + 2 ) ,wiz_read_byte( UIPR0 + 3 ) );
			printf_P( PSTR("UPORT0 : %u\n") ,( (uint16_t)wiz_read_byte( UPORT0 ) << 8 ) + (uint16_t)wiz_read_byte( UPORT0 + 1 ) );
			#endif
		}

		wiz_write_byte( IR ,0xf0 ); 								/* \PbgȊÕtONA	*/
		for ( i = 0 ;i < MAX_SOCK_NUM ;i++ ) {
			if ( ir & 0x01 ) {
				I_STATUS[i] |= wiz_read_byte( Sn_IR(i) );			/* \PbgtOޔ			*/
				wiz_write_byte( Sn_IR(i) ,I_STATUS[i] );			/* \PbgtONA		*/
			}
			ir >>= 1;
		}

		ir = wiz_read_byte( IR );
	}
}
	
#endif

/*****************************************************************************
*							W51001oCg
* Fuint16_t addr AhX
*		uint8_t  data f[^
* ߒlFvoid
*****************************************************************************/
void wiz_write_byte( uint16_t addr ,uint8_t data )
{
	/* _CNg[h					*/
	#if ( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_DIRECT_MODE__ )
	*(volatile uint8_t *)addr = data;

	/* C_CNg[h				*/
	#elif( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_INDIRECT_MODE__ )
	DISABLE_ISR();
	*(volatile uint8_t *)( IDM_AR0 ) = (uint8_t)( addr >> 8 );
	*(volatile uint8_t *)( IDM_AR1 ) = (uint8_t)addr;
	*(volatile uint8_t *)( IDM_DR  ) = data;
	ENABLE_ISR();

	/* SPI[h						*/
	#else
	DISABLE_ISR();
	SPI_MID_SPEED();
	IINCHIP_ENABLE_CS();
	spiTransfer( 0xf0 );
	spiTransfer( (uint8_t)( addr >> 8 ) );
	spiTransfer( (uint8_t)addr );
	spiTransfer( data );
	IINCHIP_DISABLE_CS();
	ENABLE_ISR();
	#endif
}

/*****************************************************************************
*							W51001oCgǂݍ
* Fuint16_t addr AhX
* ߒlFuint8_t       f[^
*****************************************************************************/
uint8_t wiz_read_byte( uint16_t addr )
{
	uint8_t data;

	/* _CNg[h					*/
	#if ( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_DIRECT_MODE__ )
	data = *(volatile uint8_t *)addr;

	/* C_CNg[h				*/
	#elif( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_INDIRECT_MODE__ )
	DISABLE_ISR();
	*(volatile uint8_t *)( IDM_AR0 ) = (uint8_t)( addr >> 8 );
	*(volatile uint8_t *)( IDM_AR1 ) = (uint8_t)addr;
	data = *(volatile uint8_t*)( IDM_DR );
	ENABLE_ISR();

	/* SPI[h						*/
	#else
	DISABLE_ISR();
	SPI_MID_SPEED();
	IINCHIP_ENABLE_CS();
	spiTransfer( 0x0f );
	spiTransfer( (uint8_t)( addr >> 8 ) );
	spiTransfer( (uint8_t)addr );
	data = spiTransfer( 0xff );
	IINCHIP_DISABLE_CS();
	ENABLE_ISR();
	#endif

	return ( data );
}

/*****************************************************************************
*							W5100փubN
* Fuint16_t addr AhX
*		void     *buf f[^
*		uint16_t len  oCg
* ߒlFvoid
*****************************************************************************/
void wiz_memcpy( uint16_t addr ,void *buf ,uint16_t len )
{
	/* _CNg[h					*/
	#if ( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_DIRECT_MODE__ )
	memcpy( (uint8_t *)addr ,buf ,len );

	/* C_CNg[h				*/
	#elif( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_INDIRECT_MODE__ )
	DISABLE_ISR();
	*(volatile uint8_t *)( IDM_AR0 ) = (uint8_t)( addr >> 8 );
	*(volatile uint8_t *)( IDM_AR1 ) = (uint8_t)addr;
	uint8_t *p = (uint8_t *)buf;
	while ( len-- ) {
		*(volatile uint8_t *)( IDM_DR ) = *p++;
	}
	ENABLE_ISR();

	/* SPI[h						*/
	#else
	uint8_t *p = (uint8_t *)buf;
	while ( len-- ) {
		wiz_write_byte( addr++ ,*p++ );
	}
	#endif
}

void wiz_memcpy_P( uint16_t addr ,const prog_void *buf ,uint16_t len )
{
	/* _CNg[h					*/
	#if ( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_DIRECT_MODE__ )
	memcpy_P( (uint8_t *)addr ,buf ,len );

	/* C_CNg[h				*/
	#elif( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_INDIRECT_MODE__ )
	DISABLE_ISR();
	*(volatile uint8_t *)( IDM_AR0 ) = (uint8_t)( addr >> 8 );
	*(volatile uint8_t *)( IDM_AR1 ) = (uint8_t)addr;
	const prog_uint8_t *p = (const prog_uint8_t *)buf;
	while ( len-- ) {
		*(volatile uint8_t *)( IDM_DR ) = pgm_read_byte( p++ );
	}
	ENABLE_ISR();

	/* SPI[h						*/
	#else
	const prog_uint8_t *p = (const prog_uint8_t *)buf;
	while ( len-- ) {
		wiz_write_byte( addr++ ,pgm_read_byte( p++ ) );
	}
	#endif
}

#if WIZ_USE_SPI_SRAM
void wiz_memcpy_SS( uint16_t addr ,SSMP buf ,uint16_t len )
{
	/* _CNg[h					*/
	#if ( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_DIRECT_MODE__ )
	memcpy_SS( (uint8_t *)addr ,buf ,len );

	/* C_CNg[h				*/
	#elif( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_INDIRECT_MODE__ )
	DISABLE_ISR();
	*(volatile uint8_t *)( IDM_AR0 ) = (uint8_t)( addr >> 8 );
	*(volatile uint8_t *)( IDM_AR1 ) = (uint8_t)addr;
	while ( len-- ) {
		*(volatile uint8_t *)( IDM_DR ) = ss_read_byte( buf++ );
	}
	ENABLE_ISR();

	/* SPI[h						*/
	#else
	while ( len-- ) {
		wiz_write_byte( addr++ ,ss_read_byte( buf++ ) );
	}
	#endif
}
#endif

/*****************************************************************************
*							W5100ubNǂݍ
* Fvoid     *buf f[^obt@
*		uint16_t addr W5100AhX
*		uint16_t len  ǂݍ݃oCg
* ߒlFvoid
*****************************************************************************/
void memcpy_WIZ( void *buf ,uint16_t addr ,uint16_t len )
{
	/* _CNg[h					*/
	#if ( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_DIRECT_MODE__ )
	memcpy( buf ,(uint8_t *)addr ,len );

	/* C_CNg[h				*/
	#elif( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_INDIRECT_MODE__ )
	DISABLE_ISR();
	*(volatile uint8_t *)( IDM_AR0 ) = (uint8_t)( addr >> 8 );
	*(volatile uint8_t *)( IDM_AR1 ) = (uint8_t)addr;
	uint8_t *p = (uint8_t *)buf;
	while ( len-- ) {
		*p++ = *(volatile uint8_t *)( IDM_DR );
	}
	ENABLE_ISR();

	/* SPI[h						*/
	#else
	uint8_t *p = (uint8_t *)buf;
	while ( len-- ) {
		*p++ = wiz_read_byte( addr++ );
	}
	#endif
}

#if WIZ_USE_SPI_SRAM
void ss_memcpy_WIZ( SSMP buf ,uint16_t addr ,uint16_t len )
{
	/* _CNg[h					*/
	#if ( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_DIRECT_MODE__ )
	ss_memcpy( buf ,(uint8_t *)addr ,len );

	/* C_CNg[h				*/
	#elif( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_INDIRECT_MODE__ )
	DISABLE_ISR();
	*(volatile uint8_t *)( IDM_AR0 ) = (uint8_t)( addr >> 8 );
	*(volatile uint8_t *)( IDM_AR1 ) = (uint8_t)addr;
	while ( len-- ) {
		ss_write_byte( buf++ ,*(volatile uint8_t *)( IDM_DR ) );
	}
	ENABLE_ISR();

	/* SPI[h						*/
	#else
	while ( len-- ) {
		ss_write_byte( buf++ ,wiz_read_byte( addr++ ) );
	}
	#endif
}
#endif

/*****************************************************************************
*							W5100ւP[h
* Fuint16_t addr ݃AhX
*		uint16_t val  ݒl
* ߒlFvoid
*****************************************************************************/
void wiz_write_word( uint16_t addr ,uint16_t val )
{
	uint8_t buf[2];
	buf[0] = (uint8_t)( val >> 8 );
	buf[1] = (uint8_t)val;
	wiz_memcpy( addr ,buf ,2 );
}

/*****************************************************************************
*							W5100P[hǂݍ
* Fuint16_t addr ǂݍ݃AhX
* ߒlFuint16_t      ǂݍݒl
*****************************************************************************/
uint16_t wiz_read_word( uint16_t addr )
{
	uint8_t buf[2];
	uint16_t dat;
	memcpy_WIZ( buf ,addr ,2 );
	dat = ( (uint16_t)buf[0] << 8 ) | (uint16_t)buf[1];
	return ( dat );
}

/*****************************************************************************
*						e\Pbg̊݃tOݒ
* FSOCKET sok \Pbgԍ
*		uint8_t ir ݒliZbgꂽrbgNAj
* ߒlFvoid
*****************************************************************************/
void wiz_setSnIR( SOCKET sok ,uint8_t ir )
{
	#if __USE_IINCHIP_INT__
	I_STATUS[sok] &= ~ir;
	#else
	wiz_write_byte( Sn_IR( sok ) ,ir );
	#endif
}

/*****************************************************************************
*						e\Pbg̊݃tO擾
* FSOCKET sok \Pbgԍ
* ߒlFvoid
*****************************************************************************/
uint8_t wiz_getSnIR( SOCKET sok )
{
	#if __USE_IINCHIP_INT__
	return ( I_STATUS[sok] );
	#else
	return ( wiz_read_byte( Sn_IR( sok ) ) );
	#endif
}

/*****************************************************************************
*						e\Pbg̎Mobt@TCY擾
* FSOCKET sok \Pbgԍ( 0 ` 3 )
* ߒlFuint16_t   obt@TCY
*****************************************************************************/
uint16_t wiz_getIINCHIP_RxMAX( SOCKET sok )
{
	return ( RSIZE[ sok ] );
}

/*****************************************************************************
*						e\Pbg̑Mobt@TCY擾
* FSOCKET sok \Pbgԍ( 0 ` 3 )
* ߒlFuint16_t   obt@TCY
*****************************************************************************/
uint16_t wiz_getIINCHIP_TxMAX( SOCKET sok )
{
	return ( SSIZE[ sok ] );
}

/*****************************************************************************
*				e\Pbg̎Mobt@AhX}XN擾
* FSOCKET sok \Pbgԍ( 0 ` 3 )
* ߒlFuint16_t   AhX}XN
*****************************************************************************/
uint16_t wiz_getIINCHIP_RxMASK( SOCKET sok )
{
	return ( RMASK[ sok ] );
}

/*****************************************************************************
*				e\Pbg̑Mobt@AhX}XN擾
* FSOCKET sok \Pbgԍ( 0 ` 3 )
* ߒlFuint16_t   AhX}XN
*****************************************************************************/
uint16_t wiz_getIINCHIP_TxMASK( SOCKET sok )
{
	return ( SMASK[ sok ] );
}

/*****************************************************************************
*				e\Pbg̎Mobt@AhX擾
* FSOCKET sok \Pbgԍ( 0 ` 3 )
* ߒlFuint16_t   AhX
*****************************************************************************/
uint16_t wiz_getIINCHIP_RxBASE( SOCKET sok )
{
	return ( RBUFBASEADDRESS[ sok ] );
}

/*****************************************************************************
*				e\Pbg̑Mobt@AhX擾
* FSOCKET sok \Pbgԍ( 0 ` 3 )
* ߒlFuint16_t   AhX
*****************************************************************************/
uint16_t wiz_getIINCHIP_TxBASE( SOCKET sok )
{
	return ( SBUFBASEADDRESS[ sok ] );
}

/*****************************************************************************
*						W5100oXin[hZbgj
* Fvoid
* ߒlFvoid
*****************************************************************************/
void wiz_iinchip_init( void )
{
	/* #RESET|[gݒ				*/
	W5100_RESET_DDR  |=  _BV( W5100_RESET_BIT );
	W5100_RESET_PORT &= ~_BV( W5100_RESET_BIT );

	/* ݋֎~					*/
	#if __USE_IINCHIP_INT__
	EIMSK &= ~_BV( __DEF_IINCHIP_INT__ );
	#endif

#if DEBUG
	puts_P( PSTR("iinchip_init()") );
#endif

	/* SPIoX				*/
#if ( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_SPI_MODE__ )
	SPI_SCS_DDR  |= _BV( SPI_SCS_BIT );
	SPI_SCS_PORT |= _BV( SPI_SCS_BIT );
	spiInit();
	SPI_MID_SPEED();
#endif

	/* n[hEGAZbg			*/
	IINCHIP_ENABLE_RESET();
	_delay_ms( 1 );
	IINCHIP_DISABLE_RESET();
}

/*****************************************************************************
*								W5100 obt@ݒ
* Fuint8_t tx_size Mobt@TCY
*		uint8_t rx_size Mobt@TCY
* ߒlFvoid
*
* MEMobt@͋8KBBe\PbgɊ蓖ĂB
* 
* tx_size / rx_size ̒l͎̒ʂƂ
*   ++-------- \Pbg3obt@TCY( 00:1K 01:2K 10:4K 11:8K )
*   ||++------ \Pbg2obt@TCY( 00:1K 01:2K 10:4K 11:8K )
*   ||||++---- \Pbg1obt@TCY( 00:1K 01:2K 10:4K 11:8K )
*   ||||||++-- \Pbg0obt@TCY( 00:1K 01:2K 10:4K 11:8K )
* 0b00000000
*
* p[^̃G[`FbN͍sȂ̂ŐȒlɃZbg邱
*
*****************************************************************************/
void wiz_sysinit( uint8_t tx_size ,uint8_t rx_size )
{
	uint8_t i;
	uint8_t sz;
	uint16_t ssum = 0;
	uint16_t rsum = 0;

	/* ݋֎~					*/
	#if __USE_IINCHIP_INT__
	EIMSK &= ~_BV( __DEF_IINCHIP_INT__ );
	#endif

#if DEBUG
	puts_P( PSTR("sysinit()") );
#endif

	/* _CNg[h		*/
#if ( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_DIRECT_MODE__ )
	wiz_setMR( MR_RST );					/* \tgEGAZbg			*/
	_delay_ms( 10 );

	#if DEBUG
	puts_P( PSTR("set direct mode") );
	#endif

	/* C_CNg[h	*/
#elif ( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_INDIRECT_MODE__ )
	wiz_setMR( MR_RST );					/* \tgEGAZbg			*/
	_delay_ms( 10 );
	wiz_setMR( MR_IND | MR_AI );			/* oX[hݒ				*/
	_delay_ms( 10 );

	#if DEBUG
	puts_P( PSTR("set indirect mode") );
	#endif

	/* SPI[h				*/
#else
	wiz_setMR( MR_RST );					/* \tgEGAZbg			*/
	_delay_ms( 10 );

	#if DEBUG
	puts_P( PSTR("set spi mode") );
	#endif

#endif

#if DEBUG
	printf_P( PSTR("MR : 0x%02x\n") ,wiz_read_byte( MR ) );
#endif

	/* W5100 obt@ݒ			*/	
	wiz_write_byte( TMSR ,tx_size );							/* Set Tx memory size for each channel		*/
	wiz_write_byte( RMSR ,rx_size );							/* Set Rx memory size for each channel		*/

	/* e\Pbgobt@쐬	*/
	SBUFBASEADDRESS[ 0 ] = __DEF_IINCHIP_MAP_TXBUF__;			/* \Pbg0 Mobt@擪AhX		*/
	RBUFBASEADDRESS[ 0 ] = __DEF_IINCHIP_MAP_RXBUF__;			/* \Pbg0 Mobt@擪AhX		*/
	for ( i = 0 ;i < MAX_SOCK_NUM ;i++ ) {

		/* Mobt@p[^쐬	*/
		SSIZE[ i ] = 0;
		SMASK[ i ] = 0;
		if ( ssum < 8192 ) {
			sz = ( tx_size >> ( i * 2 ) ) & 0x03;				/* \Pbg̃TCYp[^				*/
			if ( sz == 0 ) {									/* 1KB ?									*/
				SSIZE[ i ] = 1024;
			} else if ( sz == 1 ) {								/* 2KB ?									*/
				SSIZE[ i ] = 2048;
			} else if ( sz == 2 ) {								/* 4KB ?									*/
				SSIZE[ i ] = 4096;
			} else {											/* 8KB ?									*/
				SSIZE[ i ] = 8192;
			}

			SMASK[ i ] = SSIZE[ i ] - 1;						/* AhX}XNvZ						*/
			if ( i ) {
				SBUFBASEADDRESS[ i ] = SBUFBASEADDRESS[ i - 1 ] + SSIZE[ i - 1 ];
			}

			ssum += SSIZE[ i ];
		}

		/* Mobt@p[^쐬	*/
		RSIZE[ i ] = 0;
		RMASK[ i ] = 0;
		if ( rsum < 8192 ) {
			sz = ( rx_size >> ( i * 2 ) ) & 0x03;				/* \Pbg̃TCYp[^				*/
			if ( sz == 0 ) {									/* 1KB ?									*/
				RSIZE[ i ] = 1024;
			} else if ( sz == 1 ) {								/* 2KB ?									*/
				RSIZE[ i ] = 2048;
			} else if ( sz == 2 ) {								/* 4KB ?									*/
				RSIZE[ i ] = 4096;
			} else {											/* 8KB ?									*/
				RSIZE[ i ] = 8192;
			}

			RMASK[ i ] = RSIZE[ i ] - 1;						/* AhX}XNvZ						*/
			if ( i ) {
				RBUFBASEADDRESS[ i ] = RBUFBASEADDRESS[ i - 1 ] + RSIZE[ i - 1 ];
			}

			rsum += RSIZE[ i ];
		}
	}

#if DEBUG
	printf_P( PSTR("TMSR : 0x%02x : RMSR : 0x%02x\n") ,wiz_read_byte( TMSR ) ,wiz_read_byte( RMSR ) );
	for ( i = 0 ;i < MAX_SOCK_NUM ;i++ ) {
		printf_P( PSTR("socket %d\n") ,i );
		printf_P( PSTR("    Tx buffer address 0x%04x , mask 0x%04x , size %4ubytes\n") ,SBUFBASEADDRESS[ i ] ,SMASK[ i ] ,SSIZE[ i ] );
		printf_P( PSTR("    Rx buffer address 0x%04x , mask 0x%04x , size %4ubytes\n") ,RBUFBASEADDRESS[ i ] ,RMASK[ i ] ,RSIZE[ i ] );
	}
#endif

	/* ݋						*/
	#if __USE_IINCHIP_INT__
	uint8_t mask = IR_CONFLICT | IR_UNREACH | 0x0f;
	wiz_write_byte( IR ,mask );
	wiz_write_byte( IMR ,mask );
	mask = Sn_IR_SEND_OK | Sn_IR_TIMEOUT | Sn_IR_RECV | Sn_IR_DISCON | Sn_IR_CON;
	for ( uint8_t i = 0 ;i < MAX_SOCK_NUM ;i++ ) {
		wiz_write_byte( Sn_IR(i) ,mask );
	}
	EIMSK |= _BV( __DEF_IINCHIP_INT__ );
	#endif
}

/*****************************************************************************
*					W5100 MR(Mode register) WX^
*****************************************************************************/
void wiz_setMR( uint8_t val )
{
#if( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_INDIRECT_MODE__ )
	*(volatile uint8_t *)MR = val;

#else
	/* 	DIRECT ACCESS	*/
	wiz_write_byte( MR ,val );
#endif	
}

/*****************************************************************************
*					W5100 SHAR(MAC address) WX^
*****************************************************************************/
void wiz_setSHAR( uint8_t *addr )
{
	wiz_memcpy( SHAR0 ,addr ,6 );
}

#if 0
void wiz_getSHAR( uint8_t *addr )
{
	memcpy_WIZ( addr ,SHAR0 ,6 );
}
#endif

/*****************************************************************************
*					W5100 SIPR(Source IP address) WX^
*****************************************************************************/
void wiz_setSIPR( uint8_t *addr )
{
	wiz_memcpy( SIPR0 ,addr ,4 );
}

#if 0
void wiz_getSIPR( uint8_t *addr )
{
	memcpy_WIZ( addr ,SIPR0 ,4 );
}
#endif

/*****************************************************************************
*					W5100 GAR(gate way ip address) WX^
*****************************************************************************/
void wiz_setGAR( uint8_t *addr )
{
	wiz_memcpy( GAR0 ,addr ,4 );
}

#if 0
void wiz_getGAR( uint8_t *addr )
{
	memcpy_WIZ( addr ,GAR0 ,4 );
}
#endif

/*****************************************************************************
*					W5100 SUBR(SubnetMask address) WX^
*****************************************************************************/
void wiz_setSUBR( uint8_t *addr )
{
	wiz_memcpy( SUBR0 ,addr ,4 );
}

#if 0
void wiz_getSUBR( uint8_t *addr )
{
	memcpy_WIZ( addr ,SUBR0 ,4 );
}
#endif

#if 0
/*****************************************************************************
*				W5100 IMR(interrupt mask Enable/Disable) 
*****************************************************************************/
void wiz_setIMR( uint8_t val )
{
	wiz_write_byte( IMR ,val );
}

uint8_t wiz_getIMR( void )
{
	return ( wiz_read_byte( IMR ) );
}
#endif

/*****************************************************************************
*			W5100 SOCKET Mode(socket Mode register) WX^
*****************************************************************************/
void wiz_setSn_MR( SOCKET sok ,uint8_t val )
{
	wiz_write_byte( Sn_MR(sok) ,val );
}

#if 0
uint8_t wiz_getSn_MR( SOCKET sok )
{
	return ( wiz_read_byte( Sn_MR(sok) ) );
}
#endif

/*****************************************************************************
*			W5100 SOCKET PORT(source port register) WX^
*****************************************************************************/
void wiz_setSn_SPORT( SOCKET sok ,uint16_t port )
{
	wiz_write_word( Sn_PORT0( sok ) ,port );
}

uint16_t wiz_getSn_SPORT( SOCKET sok )
{
	return ( wiz_read_word( Sn_PORT0( sok ) ) );
}

/*****************************************************************************
*			W5100 SOCKET DHAR(Peer MAC register) WX^
*****************************************************************************/
void wiz_setSn_DHAR( SOCKET sok ,uint8_t *addr )
{
	wiz_memcpy( Sn_DHAR0( sok ) ,addr ,6 );
}

#if 0
void wiz_getSn_DHAR( SOCKET sok ,uint8_t *addr )
{
	memcpy_WIZ( addr ,Sn_DHAR0( sok ) ,6 );
}
#endif

/*****************************************************************************
*				W5100 SOCKET DIPR(Peer IP register) WX^
*****************************************************************************/
void wiz_setSn_DIPR( SOCKET sok ,uint8_t *addr )
{
	wiz_memcpy( Sn_DIPR0( sok ) ,addr ,4 );
}

#if 0
void wiz_getSn_DIPR( SOCKET sok ,uint8_t *addr )
{
	memcpy_WIZ( addr ,Sn_DIPR0( sok ) ,4 );
}
#endif

/*****************************************************************************
*			W5100 SOCKET DPORT(Peer port register) WX^
*****************************************************************************/
void wiz_setSn_DPORT( SOCKET sok ,uint16_t port )
{
	wiz_write_word( Sn_DPORT0( sok ) ,port );
}

#if 0
uint16_t wiz_getSn_DPORT( SOCKET sok )
{
	return ( wiz_read_word( Sn_DPORT0( sok ) ) );
}
#endif

#if 0
/*****************************************************************************
*		W5100 SOCKET MSSR(maximum segment size of TCP) WX^
*****************************************************************************/
void wiz_setSn_MSS( SOCKET sok ,uint16_t mss )
{
	wiz_write_word( Sn_MSSR0( sok ) ,mss );
}

uint16_t wiz_getSn_MSS( SOCKET sok )
{
	return ( wiz_read_word( Sn_MSSR0( sok ) ) );
}
#endif

#if 0
/*****************************************************************************
*				W5100 SOCKET TTL(Time to live) WX^
*****************************************************************************/
void wiz_setSn_TTL( SOCKET sok ,uint8_t ttl )
{
	wiz_write_byte( Sn_TTL( sok ) ,ttl );
}

uint8_t getSn_TTL( SOCKET sok )
{
	return ( wiz_read_byte( Sn_TTL( sok ) ) );
}
#endif

#if 0
/*****************************************************************************
* 	W5100 SOCKET PROTO(Protocol of IP Header field register) WX^
*****************************************************************************/
void wiz_setSn_PROTO( SOCKET sok ,uint8_t prto )
{
	wiz_write_byte( Sn_PROTO( sok ) ,prto );
}

uint8_t wiz_getSn_PROTO( SOCKET sok )
{
	return ( wiz_read_byte( Sn_PROTO( sok ) ) );
}
#endif

/*****************************************************************************
*		W5100 SOCKET RX_RD(Read point of Receive memory) WX^
*****************************************************************************/
void wiz_setSn_RX_RD( SOCKET sok ,uint16_t rp )
{
	wiz_write_word( Sn_RX_RD0( sok ) ,rp );
}

uint16_t wiz_getSn_RX_RD( SOCKET sok )
{
	return ( wiz_read_word( Sn_RX_RD0( sok ) ) );
}

/*****************************************************************************
*	W5100 SOCKET TX_WR(Transmit memory write pointer register) WX^
*****************************************************************************/
void wiz_setSn_TX_WR( SOCKET sok ,uint16_t wp )
{
	wiz_write_word( Sn_TX_WR0( sok ) ,wp );
}

uint16_t wiz_getSn_TX_WR( SOCKET sok )
{
	return ( wiz_read_word( Sn_TX_WR0( sok ) ) );
}

/*****************************************************************************
* 				W5100 SOCKET SnSR(socket status) WX^擾
*****************************************************************************/
uint8_t wiz_getSn_SR( SOCKET sok )
{
	return ( wiz_read_byte( Sn_SR( sok ) ) );
}

/*****************************************************************************
*	W5100 SOCKET TX_FSR(Transmit free memory size register) WX^擾
*****************************************************************************/
uint16_t wiz_getSn_TX_FSR( SOCKET sok )
{
	uint16_t val = 0;
	uint16_t val1 = 0;
	do {
		val1 = wiz_read_word( Sn_TX_FSR0(sok) );
		if ( val1 != 0 ) {
			val = wiz_read_word( Sn_TX_FSR0(sok) );
		}
	} while ( val != val1 );

	return ( val );
}

/*****************************************************************************
*		W5100 SOCKET RX_FSR(Received data size register) WX^擾
*****************************************************************************/
uint16_t wiz_getSn_RX_RSR( SOCKET sok )
{
	uint16_t val = 0;
	uint16_t val1 = 0;
	do {
		val1 = wiz_read_word( Sn_RX_RSR0(sok) );
		if ( val1 != 0 ) {
			val = wiz_read_word( Sn_RX_RSR0(sok) );
		}
	} while ( val != val1 );

	return ( val );
}

/*****************************************************************************
*					\PbgփR}hs
* FSOCKET sok  \Pbgԍ
*       uint8_t cmd R}hԍ Sn_CR_OPEN	/ Sn_CR_LISTEN / Sn_CR_CONNECT
*								 Sn_CR_DISCON / Sn_CR_CLOSE / Sn_CR_SEND
*								 Sn_CR_SEND_MAC / Sn_CR_SEND_KEEP / Sn_CR_RECV
* ߒlFvoid
*****************************************************************************/
void wiz_sockCommand( SOCKET sok ,uint8_t cmd )
{
	wiz_write_byte( Sn_CR(sok) ,cmd );
	while( wiz_read_byte( Sn_CR(sok) ) );
}
