/*#############################################################################
#                                                                          	  #
#                   				⏕֐Q   	     			          #
#                                                                          	  #
#############################################################################*/
#define __ETC_FUNCS_C__
#include "project.h"

/*****************************************************************************
*						ʗp\eLXg쐬
* FTIME *t    \
*		char *txt1 1CڃeLXgobt@(17bytes)
*       char *txt2 2CڃeLXgobt@(17bytes)
* ߒlFvoid
*****************************************************************************/
void make_dateTime_screenText( TIME *t ,char *txt1 ,char *txt2 )
{
	static const prog_char wday00[] = "Sun";
	static const prog_char wday01[] = "Mon";
	static const prog_char wday02[] = "Tue";
	static const prog_char wday03[] = "Wed";
	static const prog_char wday04[] = "Thu";
	static const prog_char wday05[] = "Fri";
	static const prog_char wday06[] = "Sat";
	static const prog_char *wday[] PROGMEM = { wday00 ,wday01 ,wday02 ,wday03 ,wday04 ,wday05 ,wday06 };

	t->wday = date_day2week( t->year ,t->month ,t->day );
	sprintf_P( txt1 ,PSTR("%04u/%02u/%02u (") ,t->year ,t->month ,t->day );
	strcpy_P( txt1 + 12 ,(prog_char *)pgm_read_word( &wday[ t->wday ] ) );
	strcpy_P( txt1 + 15 ,PSTR(")") );

	sprintf_P( txt2 ,PSTR("        %02u:%02u:%02u") ,t->hour ,t->minute ,t->second );
}

/*****************************************************************************
*		HdqʏuMACAhXς 93C46vMACAhX擾
* Fuint8_t *mac MACAhXǍݗpobt@(6bytes)
* ߒlFuint8_t      0:OK !0:NG
*****************************************************************************/
uint8_t read_akituki_mac_address( uint8_t *mac )
{
	/* wb_`FbN				*/
	if ( at93c46_read_byte( 0x00 ) != 0x40 ) return ( 1 );
	if ( at93c46_read_byte( 0x01 ) != 0x00 ) return ( 2 );
	if ( at93c46_read_byte( 0x02 ) != 0x10 ) return ( 3 );
	if ( at93c46_read_byte( 0x03 ) != 0x00 ) return ( 4 );

	/* MACAhXǂݍ			*/
	mac[ 0 ] = at93c46_read_byte( 0x04 );
	mac[ 1 ] = at93c46_read_byte( 0x05 );
	mac[ 2 ] = at93c46_read_byte( 0x06 );
	mac[ 3 ] = at93c46_read_byte( 0x07 );
	mac[ 4 ] = at93c46_read_byte( 0x08 );
	mac[ 5 ] = at93c46_read_byte( 0x09 );

	return ( 0 );
}

/*****************************************************************************
*					EEP̈netInfo\̂CRC`FbN
* Fvoid
* ߒlFuint8_t 0:OK !0:CRC error
*****************************************************************************/
uint8_t eep_check_netInfo( void )
{
	/* CRC擾			*/
	uint16_t eep_crc;
	eeprom_busy_wait();
	eeprom_read_block( &eep_crc ,(void *)0x0000 ,sizeof(uint16_t) );

	/* EEP-CRCvZ		*/
	uint16_t ram_crc = crc16_CalcEEPROM( 0x0000 + sizeof(uint16_t) ,sizeof(NET_CONFIG) );
	if ( eep_crc != ram_crc ) {
		return ( 1 );
	}

	return ( 0 );
}

/*****************************************************************************
*					netInfo\̂AVREEP֏
* Fvoid
* ߒlFvoid
*****************************************************************************/
void eep_write_netInfo( void )
{
	/* CRC		*/
	eeprom_busy_wait();
	uint16_t crc = crc16_CalcRAM( (void *)&netInfo ,sizeof(NET_CONFIG) );
	eeprom_write_block( &crc ,(void *)0x0000 ,sizeof(uint16_t) );

	/* \̏	*/
	eeprom_busy_wait();
	eeprom_write_block( (void *)&netInfo ,(void *)( 0x0000 + sizeof(uint16_t) ) ,sizeof(NET_CONFIG) );

	/* CRC`FbN		*/
	if ( eep_check_netInfo() ) {
		lcdLocate( 0 ,0 );
		lcdPuts_P( PSTR("Fatal !!        ") );
		lcdLocate( 1 ,0 );
		lcdPuts_P( PSTR("EEP WRITE ERROR ") );
		while ( 1 ) {
			wdt_reset();
		}
	}
}

/*****************************************************************************
*					netInfo\̂AVREEPǍ
* Fvoid
* ߒlFuint8_t 0:OK !0:CRC error
*****************************************************************************/
uint8_t eep_read_netInfo( void )
{
	/* CRC`FbN		*/
	if ( eep_check_netInfo() ) {
		return ( 1 );
	}

	/* \̂֓Ǎ	*/
	eeprom_busy_wait();
	eeprom_read_block( (void *)&netInfo ,(void *)( 0x0000 + sizeof(uint16_t) ) ,sizeof(NET_CONFIG) );

	return ( 0 );
}

/*****************************************************************************
*					[gIP`FbNpURLEEP擾
* Fchar     *url URLobt@
*		uint16_t size obt@TCY(Max 256)
* ߒlFvoid
*****************************************************************************/
void eep_read_remote_check_url( char *url ,uint16_t size )
{
	eeprom_busy_wait();
	eeprom_read_block( (void *)url ,(void *)0x0200 ,size );
}

/*****************************************************************************
*				[gIP`FbNpURLEEP֏
* Fchar     *url URLobt@
* ߒlFvoid
*****************************************************************************/
void eep_write_remote_check_url( char *url )
{
	/* EEPNA(256bytes)	*/
	const uint32_t *p = (const uint32_t *)0x0200;
	for ( uint8_t i = 0 ;i < 64 ;i++ ) {
		eeprom_busy_wait();
		eeprom_write_dword( (void *)(p++) ,0L );
	}

	/* 񏑍				*/
	uint16_t size = strlen( url );
	eeprom_busy_wait();
	eeprom_write_block((void *)url ,(void *)0x0200 ,size );
}

/*****************************************************************************
*					DDNSXVpURLEEP擾
* Fchar     *url URLobt@
*		uint16_t size obt@TCY(Max 256)
* ߒlFvoid
*****************************************************************************/
void eep_read_ddns_update_url( char *url ,uint16_t size )
{
	eeprom_busy_wait();
	eeprom_read_block( (void *)url ,(void *)0x0300 ,size );
}

/*****************************************************************************
*				DDNSXVpURLEEP֏
* Fchar     *url URLobt@
* ߒlFvoid
*****************************************************************************/
void eep_write_ddns_update_url( char *url )
{
	/* EEPNA(256bytes)	*/
	const uint32_t *p = (const uint32_t *)0x0300;
	for ( uint8_t i = 0 ;i < 64 ;i++ ) {
		eeprom_busy_wait();
		eeprom_write_dword( (void *)(p++) ,0L );
	}

	/* 񏑍				*/
	uint16_t size = strlen( url );
	eeprom_busy_wait();
	eeprom_write_block((void *)url ,(void *)0x0300 ,size );
}
