/*###########################################################################
#                                                                           #
#  					          WOLubW	          						#
#                                                                           #
#@RpCmFFAVR studio 4.18(SP3) + WinAVR-20100110               #
#                                                                           #
#  2012.12.01 create                                                        #
#                                                                  by nPYO  #
###########################################################################*/
#define __MAIN_C__
#include "project.h"

#if ( F_CPU == 8000000UL )
#define AJ_CLK 8
#elif ( F_CPU == 16000000UL )
#define AJ_CLK 4
#elif ( F_CPU == 1000000UL )
#define AJ_CLK 64
#endif

/*****************************************************************************
*					timer1(16bit)ɂ10msec̊荞
*****************************************************************************/
ISR( TIMER1_COMPA_vect )
{
	static uint8_t aj = 0;

	/* 񊄂荞݃^C~Oݒ	*/
	OCR1A += TIMER_MS_TO_COUNT( 10 );	/* 8MHz  = 78.125					*/
	if ( ++aj == AJ_CLK ) {				/* 덷␳						*/
		aj = 0;
		OCR1A++;
	}

	/* lbg[Np^C}[	*/
	net_timer();

	/* \^C~Op				*/
	if ( ++sys_count300msec >= 30 ) {
		sys_tick300msec = 1;
		sys_count300msec = 0;
	}

	/* {^hCo쓮			*/
	keysWatchKey();
}

/*****************************************************************************
*								n[hEGA
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void hardwareInit( void )
{
	/*  PortB +--------7: ------ : XTAL                                         */
	/*        |+-------6: ------ : XTAL                                         */
	/*        ||+------5: Out(H) : SPI-SCK                                      */
	/*        |||+-----4: HI-Z   : SPI-MISO                                     */
	/*        ||||+----3: Out(H) : SPI-MOSI                                     */
	/*        |||||+---2: Out(H) : AT93C46D(#CS)                                */
	/*        ||||||+--1: Out(H) : W5100(#SCS)                                  */
	/*        |||||||+-0: Out(L) : W5100(#RESET)                                */
	DDRB  = 0b00101111;
	PORTB = 0b00101110;

	/*  PortC +--------7: ------ :                                              */
	/*        |+-------6: ------ : #RESET                                       */
	/*        ||+------5: Out(L) : LCD(E)                                       */
	/*        |||+-----4: Out(L) : LCD(RS)                                      */
	/*        ||||+----3: HI-Z   : LCD DB7                                      */
	/*        |||||+---2: HI-Z   : LCD DB6                                      */
	/*        ||||||+--1: HI-Z   : LCD DB5                                      */
	/*        |||||||+-0: HI-Z   : LCD DB4                                      */
	DDRC  = 0b00000000;
	PORTC = 0b00110000;

	/*  PortD +--------7: Pullup : SW5                                          */
	/*        |+-------6: Out(L) : LCDobNCg(0:OFF 1:ON)                  */
	/*        ||+------5: Pullup : SW4                                          */
	/*        |||+-----4: Pullup : SW3                                          */
	/*        ||||+----3: Out(L) : LCDd(0:OFF 1:ON)                          */
	/*        |||||+---2: Out(L) : LCD(RW)                                      */
	/*        ||||||+--1: Pullup : SW2                                          */
	/*        |||||||+-0: Pullup : SW1                                          */
	DDRD  = 0b01001100;
	PORTD = 0b10110011;

	/* AiORp[^					*/
	ACSR = _BV(ACD);

	/* EIb`hbNݒ				*/
	wdt_enable( WDTO_8S );

	/* LCD						*/
	lcdInit( ON );

	/* AT93C46D 					*/
	at93c46_init();

	/* {^hCo				*/
	keysInit();

	/*^C}[0(8bit) PWMݒ			*/
	TCCR0A = _BV(COM0A1) | _BV(COM0A0) | _BV(WGM00);	/* ^C}OCR0AƂ̔rvHIGHA^C}0ɂȂLOW	*/
	TCCR0B = 3;							/* F_CPU / 64						*/
	OCR0A = 0;							/* 0:őPx  255:ŒPx				*/
	TCNT0 = 0;

	/* ^C}[1(16bit) 10msec̊荞ݐݒ	*/
	TCCR1B =  0x05;						/* VXeNbN1024			*/
	OCR1A  =  TIMER_MS_TO_COUNT( 10 );	/* F_CPU = 16MHzŌvZ					*/
	TCNT1  =  0;
	TIMSK1 |= _BV(OCIE1A);

	/* O[oC^vgL		*/
	sei();
}

/*****************************************************************************
*								C
*****************************************************************************/
int main( void )
{
	uint8_t screenIndex = 0;
	uint8_t itemIndex = 0;
	uint8_t init = 0;

	/* eytF			*/
	hardwareInit();

	/* lbg[Np[^ݒ	*/
	init = 0;
	if ( ( keysNowKeyNumber() == KEY_ENTER ) || eep_read_netInfo() ) {	/* EEPf[^Ǎ	*/
		memset( &netInfo ,0x00 ,sizeof(netInfo) );
		lcdLocate( 0 ,0 );
		lcdPuts_P( PSTR("EEP CRC ERROR !!") );
		lcdLocate( 1 ,0 );
		lcdPuts_P( PSTR("load default val") );
		init = 1;
	}

	if ( read_akituki_mac_address( netInfo.mac ) != 0 ) {	/* MAC擾			*/
		lcdLocate( 0 ,0 );
		lcdPuts_P( PSTR("MAC address read") );
		lcdLocate( 1 ,0 );
		lcdPuts_P( PSTR("akituki-error !!") );
		while ( 1 );
	}

	if ( init ) {											/* ftHglݒ	*/
		char buf[ 256 ];
		strcpy_P( netInfo.hostname ,PSTR("wol") );			/* zXg			*/
		strcpy_P( netInfo.ntpcName ,PSTR("ntp.nict.jp") );	/* NTPT[o[	*/
		netInfo.dhcpMode = IP_DYNAMIC;						/* DHCP[hݒ	*/
		netInfo.wolPort = DELAULT_WOL_PORT;					/* WOLgp|[g	*/
		eep_write_netInfo();								/* EEP֕ۑ		*/

		strcpy_s_P( buf ,sizeof(buf) ,PSTR("http://npyo.net/checkip.cgi") );
		eep_write_remote_check_url( buf );

		strcpy_s_P( buf ,sizeof(buf) ,PSTR("http://") );
		eep_write_ddns_update_url( buf );

		_delay_ms( 2000 );
	}

	/* {^ݒ						*/
	keysRepetEnable( KEY_UP ,ON );
	keysRepetEnable( KEY_DOWN ,ON );
	keysRepetEnable( KEY_LEFT ,ON );
	keysRepetEnable( KEY_RIGHT ,ON );

	/* lbg[N				*/
	net_init();	

	/* C[v						*/
	itemIndex = 0;
	while ( 1 ) {
		keysClear();

		if ( screenIndex == 0 ) {
			screenIndex = main_screen( itemIndex );		/* C		*/

		} else if ( screenIndex == 110 ) {
			screenIndex = sub_screen110();				/* Cj[	*/
			itemIndex = 0;

		} else if ( screenIndex == 111 ) {				/* NTPCM		*/
			sub_screen111();
			itemIndex = 0;
			screenIndex = 0;

		} else if ( screenIndex == 112 ) {				/* 蓮ݒ		*/
			sub_screen112();
			itemIndex = 0;
			screenIndex = 0;

		} else if ( screenIndex == 121 ) {				/* |[gԍύX	*/
			sub_screen121();
			itemIndex = 1;
			screenIndex = 0;

		} else if ( screenIndex == 122 ) {				/* DHCPύX		*/
			sub_screen122();
			itemIndex = 2;
			screenIndex = 0;

		} else if ( screenIndex == 123 ) {				/* IPAhXύX	*/
			sub_screen123( 1 );
			itemIndex = 3;
			screenIndex = 0;

		} else if ( screenIndex == 124 ) {				/* TulbgύX	*/
			sub_screen123( 2 );
			itemIndex = 4;
			screenIndex = 0;

		} else if ( screenIndex == 125 ) {				/* [^[ύX		*/
			sub_screen123( 3 );
			itemIndex = 5;
			screenIndex = 0;

		} else if ( screenIndex == 126 ) {				/* DNSύX			*/
			sub_screen123( 4 );
			itemIndex = 6;
			screenIndex = 0;

		}

	}
}
